// python wrapper for vtkGDCMImageReader2
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkGDCMImageReader2.h"

#if defined(PYTHON_PACKAGE)
#define PYTHON_PACKAGE_SCOPE PYTHON_PACKAGE "."
#else
#define PYTHON_PACKAGE_SCOPE
#endif

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkGDCMImageReader2(PyObject *dict); }
extern "C" { PyObject *PyvtkGDCMImageReader2_ClassNew(); }


static PyObject *
PyvtkGDCMImageReader2_IsTypeOf(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkGDCMImageReader2::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGDCMImageReader2_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGDCMImageReader2 *op = static_cast<vtkGDCMImageReader2 *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkGDCMImageReader2::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGDCMImageReader2_SafeDownCast(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkGDCMImageReader2 *tempr = vtkGDCMImageReader2::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGDCMImageReader2_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGDCMImageReader2 *op = static_cast<vtkGDCMImageReader2 *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkGDCMImageReader2 *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkGDCMImageReader2::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(nullptr);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
    else if (tempr != nullptr)
    {
      ap.DeleteVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGDCMImageReader2_GetNumberOfGenerationsFromBaseType(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "GetNumberOfGenerationsFromBaseType");

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    long long tempr = vtkGDCMImageReader2::GetNumberOfGenerationsFromBaseType(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGDCMImageReader2_GetNumberOfGenerationsFromBase(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNumberOfGenerationsFromBase");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGDCMImageReader2 *op = static_cast<vtkGDCMImageReader2 *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    long long tempr = (ap.IsBound() ?
      op->GetNumberOfGenerationsFromBase(temp0) :
      op->vtkGDCMImageReader2::GetNumberOfGenerationsFromBase(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGDCMImageReader2_CanReadFile(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "CanReadFile");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGDCMImageReader2 *op = static_cast<vtkGDCMImageReader2 *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetFilePath(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->CanReadFile(temp0) :
      op->vtkGDCMImageReader2::CanReadFile(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGDCMImageReader2_GetFileExtensions(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetFileExtensions");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGDCMImageReader2 *op = static_cast<vtkGDCMImageReader2 *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetFileExtensions() :
      op->vtkGDCMImageReader2::GetFileExtensions());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGDCMImageReader2_GetDescriptiveName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetDescriptiveName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGDCMImageReader2 *op = static_cast<vtkGDCMImageReader2 *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetDescriptiveName() :
      op->vtkGDCMImageReader2::GetDescriptiveName());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGDCMImageReader2_GetDirectionCosines(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetDirectionCosines");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGDCMImageReader2 *op = static_cast<vtkGDCMImageReader2 *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkMatrix4x4 *tempr = (ap.IsBound() ?
      op->GetDirectionCosines() :
      op->vtkGDCMImageReader2::GetDirectionCosines());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGDCMImageReader2_SetMedicalImageProperties(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetMedicalImageProperties");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGDCMImageReader2 *op = static_cast<vtkGDCMImageReader2 *>(vp);

  vtkMedicalImageProperties *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkMedicalImageProperties"))
  {
    if (ap.IsBound())
    {
      op->SetMedicalImageProperties(temp0);
    }
    else
    {
      op->vtkGDCMImageReader2::SetMedicalImageProperties(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGDCMImageReader2_GetLoadOverlays(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetLoadOverlays");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGDCMImageReader2 *op = static_cast<vtkGDCMImageReader2 *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetLoadOverlays() :
      op->vtkGDCMImageReader2::GetLoadOverlays());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGDCMImageReader2_SetLoadOverlays(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetLoadOverlays");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGDCMImageReader2 *op = static_cast<vtkGDCMImageReader2 *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetLoadOverlays(temp0);
    }
    else
    {
      op->vtkGDCMImageReader2::SetLoadOverlays(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGDCMImageReader2_LoadOverlaysOn(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "LoadOverlaysOn");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGDCMImageReader2 *op = static_cast<vtkGDCMImageReader2 *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->LoadOverlaysOn();
    }
    else
    {
      op->vtkGDCMImageReader2::LoadOverlaysOn();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGDCMImageReader2_LoadOverlaysOff(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "LoadOverlaysOff");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGDCMImageReader2 *op = static_cast<vtkGDCMImageReader2 *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->LoadOverlaysOff();
    }
    else
    {
      op->vtkGDCMImageReader2::LoadOverlaysOff();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGDCMImageReader2_GetLoadIconImage(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetLoadIconImage");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGDCMImageReader2 *op = static_cast<vtkGDCMImageReader2 *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetLoadIconImage() :
      op->vtkGDCMImageReader2::GetLoadIconImage());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGDCMImageReader2_SetLoadIconImage(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetLoadIconImage");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGDCMImageReader2 *op = static_cast<vtkGDCMImageReader2 *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetLoadIconImage(temp0);
    }
    else
    {
      op->vtkGDCMImageReader2::SetLoadIconImage(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGDCMImageReader2_LoadIconImageOn(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "LoadIconImageOn");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGDCMImageReader2 *op = static_cast<vtkGDCMImageReader2 *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->LoadIconImageOn();
    }
    else
    {
      op->vtkGDCMImageReader2::LoadIconImageOn();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGDCMImageReader2_LoadIconImageOff(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "LoadIconImageOff");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGDCMImageReader2 *op = static_cast<vtkGDCMImageReader2 *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->LoadIconImageOff();
    }
    else
    {
      op->vtkGDCMImageReader2::LoadIconImageOff();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGDCMImageReader2_GetLossyFlag(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetLossyFlag");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGDCMImageReader2 *op = static_cast<vtkGDCMImageReader2 *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetLossyFlag() :
      op->vtkGDCMImageReader2::GetLossyFlag());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGDCMImageReader2_SetLossyFlag(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetLossyFlag");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGDCMImageReader2 *op = static_cast<vtkGDCMImageReader2 *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetLossyFlag(temp0);
    }
    else
    {
      op->vtkGDCMImageReader2::SetLossyFlag(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGDCMImageReader2_LossyFlagOn(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "LossyFlagOn");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGDCMImageReader2 *op = static_cast<vtkGDCMImageReader2 *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->LossyFlagOn();
    }
    else
    {
      op->vtkGDCMImageReader2::LossyFlagOn();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGDCMImageReader2_LossyFlagOff(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "LossyFlagOff");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGDCMImageReader2 *op = static_cast<vtkGDCMImageReader2 *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->LossyFlagOff();
    }
    else
    {
      op->vtkGDCMImageReader2::LossyFlagOff();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGDCMImageReader2_GetNumberOfOverlays(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNumberOfOverlays");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGDCMImageReader2 *op = static_cast<vtkGDCMImageReader2 *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetNumberOfOverlays() :
      op->vtkGDCMImageReader2::GetNumberOfOverlays());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGDCMImageReader2_GetNumberOfIconImages(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNumberOfIconImages");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGDCMImageReader2 *op = static_cast<vtkGDCMImageReader2 *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetNumberOfIconImages() :
      op->vtkGDCMImageReader2::GetNumberOfIconImages());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGDCMImageReader2_GetOverlayPort(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetOverlayPort");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGDCMImageReader2 *op = static_cast<vtkGDCMImageReader2 *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    vtkAlgorithmOutput *tempr = (ap.IsBound() ?
      op->GetOverlayPort(temp0) :
      op->vtkGDCMImageReader2::GetOverlayPort(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGDCMImageReader2_GetIconImagePort(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetIconImagePort");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGDCMImageReader2 *op = static_cast<vtkGDCMImageReader2 *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkAlgorithmOutput *tempr = (ap.IsBound() ?
      op->GetIconImagePort() :
      op->vtkGDCMImageReader2::GetIconImagePort());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGDCMImageReader2_GetOverlay(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetOverlay");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGDCMImageReader2 *op = static_cast<vtkGDCMImageReader2 *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    vtkImageData *tempr = (ap.IsBound() ?
      op->GetOverlay(temp0) :
      op->vtkGDCMImageReader2::GetOverlay(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGDCMImageReader2_GetIconImage(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetIconImage");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGDCMImageReader2 *op = static_cast<vtkGDCMImageReader2 *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkImageData *tempr = (ap.IsBound() ?
      op->GetIconImage() :
      op->vtkGDCMImageReader2::GetIconImage());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGDCMImageReader2_GetApplyLookupTable(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetApplyLookupTable");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGDCMImageReader2 *op = static_cast<vtkGDCMImageReader2 *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetApplyLookupTable() :
      op->vtkGDCMImageReader2::GetApplyLookupTable());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGDCMImageReader2_SetApplyLookupTable(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetApplyLookupTable");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGDCMImageReader2 *op = static_cast<vtkGDCMImageReader2 *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetApplyLookupTable(temp0);
    }
    else
    {
      op->vtkGDCMImageReader2::SetApplyLookupTable(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGDCMImageReader2_ApplyLookupTableOn(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "ApplyLookupTableOn");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGDCMImageReader2 *op = static_cast<vtkGDCMImageReader2 *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->ApplyLookupTableOn();
    }
    else
    {
      op->vtkGDCMImageReader2::ApplyLookupTableOn();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGDCMImageReader2_ApplyLookupTableOff(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "ApplyLookupTableOff");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGDCMImageReader2 *op = static_cast<vtkGDCMImageReader2 *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->ApplyLookupTableOff();
    }
    else
    {
      op->vtkGDCMImageReader2::ApplyLookupTableOff();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGDCMImageReader2_GetApplyYBRToRGB(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetApplyYBRToRGB");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGDCMImageReader2 *op = static_cast<vtkGDCMImageReader2 *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetApplyYBRToRGB() :
      op->vtkGDCMImageReader2::GetApplyYBRToRGB());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGDCMImageReader2_SetApplyYBRToRGB(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetApplyYBRToRGB");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGDCMImageReader2 *op = static_cast<vtkGDCMImageReader2 *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetApplyYBRToRGB(temp0);
    }
    else
    {
      op->vtkGDCMImageReader2::SetApplyYBRToRGB(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGDCMImageReader2_ApplyYBRToRGBOn(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "ApplyYBRToRGBOn");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGDCMImageReader2 *op = static_cast<vtkGDCMImageReader2 *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->ApplyYBRToRGBOn();
    }
    else
    {
      op->vtkGDCMImageReader2::ApplyYBRToRGBOn();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGDCMImageReader2_ApplyYBRToRGBOff(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "ApplyYBRToRGBOff");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGDCMImageReader2 *op = static_cast<vtkGDCMImageReader2 *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->ApplyYBRToRGBOff();
    }
    else
    {
      op->vtkGDCMImageReader2::ApplyYBRToRGBOff();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGDCMImageReader2_GetImageFormat(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetImageFormat");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGDCMImageReader2 *op = static_cast<vtkGDCMImageReader2 *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetImageFormat() :
      op->vtkGDCMImageReader2::GetImageFormat());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGDCMImageReader2_GetPlanarConfiguration(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetPlanarConfiguration");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGDCMImageReader2 *op = static_cast<vtkGDCMImageReader2 *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetPlanarConfiguration() :
      op->vtkGDCMImageReader2::GetPlanarConfiguration());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGDCMImageReader2_GetImagePositionPatient(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetImagePositionPatient");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGDCMImageReader2 *op = static_cast<vtkGDCMImageReader2 *>(vp);

  size_t sizer = 3;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    double *tempr = (ap.IsBound() ?
      op->GetImagePositionPatient() :
      op->vtkGDCMImageReader2::GetImagePositionPatient());

    if (!ap.ErrorOccurred())
    {
      result = vtkPythonArgs::BuildTuple(tempr, sizer);
    }
  }

  return result;
}


static PyObject *
PyvtkGDCMImageReader2_GetImageOrientationPatient(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetImageOrientationPatient");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGDCMImageReader2 *op = static_cast<vtkGDCMImageReader2 *>(vp);

  size_t sizer = 6;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    double *tempr = (ap.IsBound() ?
      op->GetImageOrientationPatient() :
      op->vtkGDCMImageReader2::GetImageOrientationPatient());

    if (!ap.ErrorOccurred())
    {
      result = vtkPythonArgs::BuildTuple(tempr, sizer);
    }
  }

  return result;
}


static PyObject *
PyvtkGDCMImageReader2_GetCurve(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetCurve");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGDCMImageReader2 *op = static_cast<vtkGDCMImageReader2 *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkPolyData *tempr = (ap.IsBound() ?
      op->GetCurve() :
      op->vtkGDCMImageReader2::GetCurve());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGDCMImageReader2_SetCurve(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetCurve");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGDCMImageReader2 *op = static_cast<vtkGDCMImageReader2 *>(vp);

  vtkPolyData *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkPolyData"))
  {
    if (ap.IsBound())
    {
      op->SetCurve(temp0);
    }
    else
    {
      op->vtkGDCMImageReader2::SetCurve(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGDCMImageReader2_GetShift(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetShift");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGDCMImageReader2 *op = static_cast<vtkGDCMImageReader2 *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    double tempr = (ap.IsBound() ?
      op->GetShift() :
      op->vtkGDCMImageReader2::GetShift());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGDCMImageReader2_GetScale(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetScale");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGDCMImageReader2 *op = static_cast<vtkGDCMImageReader2 *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    double tempr = (ap.IsBound() ?
      op->GetScale() :
      op->vtkGDCMImageReader2::GetScale());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkGDCMImageReader2_Methods[] = {
  {"IsTypeOf", PyvtkGDCMImageReader2_IsTypeOf, METH_VARARGS,
   "IsTypeOf(type:str) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\nReturn 1 if this class type is the same type of (or a subclass\nof) the named class. Returns 0 otherwise. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"IsA", PyvtkGDCMImageReader2_IsA, METH_VARARGS,
   "IsA(self, type:str) -> int\nC++: vtkTypeBool IsA(const char *type) override;\n\nReturn 1 if this class is the same type of (or a subclass of) the\nnamed class. Returns 0 otherwise. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"SafeDownCast", PyvtkGDCMImageReader2_SafeDownCast, METH_VARARGS,
   "SafeDownCast(o:vtkObjectBase) -> vtkGDCMImageReader2\nC++: static vtkGDCMImageReader2 *SafeDownCast(vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkGDCMImageReader2_NewInstance, METH_VARARGS,
   "NewInstance(self) -> vtkGDCMImageReader2\nC++: vtkGDCMImageReader2 *NewInstance()\n\n"},
  {"GetNumberOfGenerationsFromBaseType", PyvtkGDCMImageReader2_GetNumberOfGenerationsFromBaseType, METH_VARARGS,
   "GetNumberOfGenerationsFromBaseType(type:str) -> int\nC++: static vtkIdType GetNumberOfGenerationsFromBaseType(\n    const char *type)\n\nGiven a the name of a base class of this class type, return the\ndistance of inheritance between this class type and the named\nclass (how many generations of inheritance are there between this\nclass and the named class). If the named class is not in this\nclass's inheritance tree, return a negative value. Valid\nresponses will always be nonnegative. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"GetNumberOfGenerationsFromBase", PyvtkGDCMImageReader2_GetNumberOfGenerationsFromBase, METH_VARARGS,
   "GetNumberOfGenerationsFromBase(self, type:str) -> int\nC++: vtkIdType GetNumberOfGenerationsFromBase(const char *type)\n    override;\n\nGiven the name of a base class of this class type, return the\ndistance of inheritance between this class type and the named\nclass (how many generations of inheritance are there between this\nclass and the named class). If the named class is not in this\nclass's inheritance tree, return a negative value. Valid\nresponses will always be nonnegative. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"CanReadFile", PyvtkGDCMImageReader2_CanReadFile, METH_VARARGS,
   "CanReadFile(self, fname:str) -> int\nC++: virtual int CanReadFile(const char *fname)\n\n\n"},
  {"GetFileExtensions", PyvtkGDCMImageReader2_GetFileExtensions, METH_VARARGS,
   "GetFileExtensions(self) -> str\nC++: virtual const char *GetFileExtensions()\n\nValid extensions\n"},
  {"GetDescriptiveName", PyvtkGDCMImageReader2_GetDescriptiveName, METH_VARARGS,
   "GetDescriptiveName(self) -> str\nC++: virtual const char *GetDescriptiveName()\n\nA descriptive name for this format\n"},
  {"GetDirectionCosines", PyvtkGDCMImageReader2_GetDirectionCosines, METH_VARARGS,
   "GetDirectionCosines(self) -> vtkMatrix4x4\nC++: virtual vtkMatrix4x4 *GetDirectionCosines()\n\nGet the Image Position (Patient) as stored in the DICOM file This\nis a read-only data member\n"},
  {"SetMedicalImageProperties", PyvtkGDCMImageReader2_SetMedicalImageProperties, METH_VARARGS,
   "SetMedicalImageProperties(self, pd:vtkMedicalImageProperties)\n    -> None\nC++: virtual void SetMedicalImageProperties(\n    vtkMedicalImageProperties *pd)\n\n"},
  {"GetLoadOverlays", PyvtkGDCMImageReader2_GetLoadOverlays, METH_VARARGS,
   "GetLoadOverlays(self) -> int\nC++: virtual int GetLoadOverlays()\n\nSpecifically request to load the overlay into the gdcm-VTK layer\n(gdcm always loads them when found). If no overlay is found in\nthe image, then the vtkImageData for the overlay will be empty.\n"},
  {"SetLoadOverlays", PyvtkGDCMImageReader2_SetLoadOverlays, METH_VARARGS,
   "SetLoadOverlays(self, _arg:int) -> None\nC++: virtual void SetLoadOverlays(int _arg)\n\nSpecifically request to load the overlay into the gdcm-VTK layer\n(gdcm always loads them when found). If no overlay is found in\nthe image, then the vtkImageData for the overlay will be empty.\n"},
  {"LoadOverlaysOn", PyvtkGDCMImageReader2_LoadOverlaysOn, METH_VARARGS,
   "LoadOverlaysOn(self) -> None\nC++: virtual void LoadOverlaysOn()\n\nSpecifically request to load the overlay into the gdcm-VTK layer\n(gdcm always loads them when found). If no overlay is found in\nthe image, then the vtkImageData for the overlay will be empty.\n"},
  {"LoadOverlaysOff", PyvtkGDCMImageReader2_LoadOverlaysOff, METH_VARARGS,
   "LoadOverlaysOff(self) -> None\nC++: virtual void LoadOverlaysOff()\n\nSpecifically request to load the overlay into the gdcm-VTK layer\n(gdcm always loads them when found). If no overlay is found in\nthe image, then the vtkImageData for the overlay will be empty.\n"},
  {"GetLoadIconImage", PyvtkGDCMImageReader2_GetLoadIconImage, METH_VARARGS,
   "GetLoadIconImage(self) -> int\nC++: virtual int GetLoadIconImage()\n\nSet/Get whether or not to load the Icon as vtkImageData (if found\nin the DICOM file)\n"},
  {"SetLoadIconImage", PyvtkGDCMImageReader2_SetLoadIconImage, METH_VARARGS,
   "SetLoadIconImage(self, _arg:int) -> None\nC++: virtual void SetLoadIconImage(int _arg)\n\nSet/Get whether or not to load the Icon as vtkImageData (if found\nin the DICOM file)\n"},
  {"LoadIconImageOn", PyvtkGDCMImageReader2_LoadIconImageOn, METH_VARARGS,
   "LoadIconImageOn(self) -> None\nC++: virtual void LoadIconImageOn()\n\nSet/Get whether or not to load the Icon as vtkImageData (if found\nin the DICOM file)\n"},
  {"LoadIconImageOff", PyvtkGDCMImageReader2_LoadIconImageOff, METH_VARARGS,
   "LoadIconImageOff(self) -> None\nC++: virtual void LoadIconImageOff()\n\nSet/Get whether or not to load the Icon as vtkImageData (if found\nin the DICOM file)\n"},
  {"GetLossyFlag", PyvtkGDCMImageReader2_GetLossyFlag, METH_VARARGS,
   "GetLossyFlag(self) -> int\nC++: virtual int GetLossyFlag()\n\nSet/Get whether or not the image was compressed using a lossy\ncompression algorithm\n"},
  {"SetLossyFlag", PyvtkGDCMImageReader2_SetLossyFlag, METH_VARARGS,
   "SetLossyFlag(self, _arg:int) -> None\nC++: virtual void SetLossyFlag(int _arg)\n\nSet/Get whether or not the image was compressed using a lossy\ncompression algorithm\n"},
  {"LossyFlagOn", PyvtkGDCMImageReader2_LossyFlagOn, METH_VARARGS,
   "LossyFlagOn(self) -> None\nC++: virtual void LossyFlagOn()\n\nSet/Get whether or not the image was compressed using a lossy\ncompression algorithm\n"},
  {"LossyFlagOff", PyvtkGDCMImageReader2_LossyFlagOff, METH_VARARGS,
   "LossyFlagOff(self) -> None\nC++: virtual void LossyFlagOff()\n\nSet/Get whether or not the image was compressed using a lossy\ncompression algorithm\n"},
  {"GetNumberOfOverlays", PyvtkGDCMImageReader2_GetNumberOfOverlays, METH_VARARGS,
   "GetNumberOfOverlays(self) -> int\nC++: virtual int GetNumberOfOverlays()\n\nRead only: number of overlays as found in this image (multiple\noverlays per slice is allowed) Only valid when LoadOverlays is\ntrue\n"},
  {"GetNumberOfIconImages", PyvtkGDCMImageReader2_GetNumberOfIconImages, METH_VARARGS,
   "GetNumberOfIconImages(self) -> int\nC++: virtual int GetNumberOfIconImages()\n\nRead only: number of icon image (there can only be zero or one\nicon per file) Only valid when LoadIconImage is true\n"},
  {"GetOverlayPort", PyvtkGDCMImageReader2_GetOverlayPort, METH_VARARGS,
   "GetOverlayPort(self, index:int) -> vtkAlgorithmOutput\nC++: vtkAlgorithmOutput *GetOverlayPort(int index)\n\nGet Overlay/IconImage Remember to ALWAYS use those methods in\nyour code, as the internal number for the output port is not\nguaranteed to remain the same, as features are added to the\nreader\n"},
  {"GetIconImagePort", PyvtkGDCMImageReader2_GetIconImagePort, METH_VARARGS,
   "GetIconImagePort(self) -> vtkAlgorithmOutput\nC++: vtkAlgorithmOutput *GetIconImagePort()\n\nGet Overlay/IconImage Remember to ALWAYS use those methods in\nyour code, as the internal number for the output port is not\nguaranteed to remain the same, as features are added to the\nreader\n"},
  {"GetOverlay", PyvtkGDCMImageReader2_GetOverlay, METH_VARARGS,
   "GetOverlay(self, i:int) -> vtkImageData\nC++: vtkImageData *GetOverlay(int i)\n\nGet Overlay/IconImage Remember to ALWAYS use those methods in\nyour code, as the internal number for the output port is not\nguaranteed to remain the same, as features are added to the\nreader\n"},
  {"GetIconImage", PyvtkGDCMImageReader2_GetIconImage, METH_VARARGS,
   "GetIconImage(self) -> vtkImageData\nC++: vtkImageData *GetIconImage()\n\nGet Overlay/IconImage Remember to ALWAYS use those methods in\nyour code, as the internal number for the output port is not\nguaranteed to remain the same, as features are added to the\nreader\n"},
  {"GetApplyLookupTable", PyvtkGDCMImageReader2_GetApplyLookupTable, METH_VARARGS,
   "GetApplyLookupTable(self) -> int\nC++: virtual int GetApplyLookupTable()\n\nLoad image with its associated Lookup Table\n"},
  {"SetApplyLookupTable", PyvtkGDCMImageReader2_SetApplyLookupTable, METH_VARARGS,
   "SetApplyLookupTable(self, _arg:int) -> None\nC++: virtual void SetApplyLookupTable(int _arg)\n\nLoad image with its associated Lookup Table\n"},
  {"ApplyLookupTableOn", PyvtkGDCMImageReader2_ApplyLookupTableOn, METH_VARARGS,
   "ApplyLookupTableOn(self) -> None\nC++: virtual void ApplyLookupTableOn()\n\nLoad image with its associated Lookup Table\n"},
  {"ApplyLookupTableOff", PyvtkGDCMImageReader2_ApplyLookupTableOff, METH_VARARGS,
   "ApplyLookupTableOff(self) -> None\nC++: virtual void ApplyLookupTableOff()\n\nLoad image with its associated Lookup Table\n"},
  {"GetApplyYBRToRGB", PyvtkGDCMImageReader2_GetApplyYBRToRGB, METH_VARARGS,
   "GetApplyYBRToRGB(self) -> int\nC++: virtual int GetApplyYBRToRGB()\n\nLoad image as YBR\n"},
  {"SetApplyYBRToRGB", PyvtkGDCMImageReader2_SetApplyYBRToRGB, METH_VARARGS,
   "SetApplyYBRToRGB(self, _arg:int) -> None\nC++: virtual void SetApplyYBRToRGB(int _arg)\n\nLoad image as YBR\n"},
  {"ApplyYBRToRGBOn", PyvtkGDCMImageReader2_ApplyYBRToRGBOn, METH_VARARGS,
   "ApplyYBRToRGBOn(self) -> None\nC++: virtual void ApplyYBRToRGBOn()\n\nLoad image as YBR\n"},
  {"ApplyYBRToRGBOff", PyvtkGDCMImageReader2_ApplyYBRToRGBOff, METH_VARARGS,
   "ApplyYBRToRGBOff(self) -> None\nC++: virtual void ApplyYBRToRGBOff()\n\nLoad image as YBR\n"},
  {"GetImageFormat", PyvtkGDCMImageReader2_GetImageFormat, METH_VARARGS,
   "GetImageFormat(self) -> int\nC++: virtual int GetImageFormat()\n\nReturn VTK_LUMINANCE, VTK_INVERSE_LUMINANCE, VTK_RGB, VTK_RGBA,\nVTK_LOOKUP_TABLE, VTK_YBR or VTK_CMYK or 0 when ImageFormat is\nnot handled. Warning: For color image, PlanarConfiguration need\nto be taken into account.\n"},
  {"GetPlanarConfiguration", PyvtkGDCMImageReader2_GetPlanarConfiguration, METH_VARARGS,
   "GetPlanarConfiguration(self) -> int\nC++: virtual int GetPlanarConfiguration()\n\nReturn the Planar Configuration. This simply means that the\ninternal DICOM image was stored using a particular planar\nconfiguration (most of the time: 0) For monochrome image,\nPlanarConfiguration is always 0\n"},
  {"GetImagePositionPatient", PyvtkGDCMImageReader2_GetImagePositionPatient, METH_VARARGS,
   "GetImagePositionPatient(self) -> (float, float, float)\nC++: virtual double *GetImagePositionPatient()\n\nReturn the 'raw' information stored in the DICOM file: In case of\na series of multiple files, only the first file is considered.\nThe Image Orientation (Patient) is guaranteed to remain the same,\nand image Image Position (Patient) in other slice can be computed\nusing the ZSpacing (3rd dimension) (0020,0032) DS\n[87.774866\\-182.908510\\168.629671]       #  32, 3\nImagePositionPatient (0020,0037) DS\n[0.001479\\0.999989\\-0.004376\\-0.002039\\-0.004372\\-0.999988] # \n58, 6 ImageOrientationPatient\n"},
  {"GetImageOrientationPatient", PyvtkGDCMImageReader2_GetImageOrientationPatient, METH_VARARGS,
   "GetImageOrientationPatient(self) -> (float, float, float, float,\n    float, float)\nC++: virtual double *GetImageOrientationPatient()\n\nReturn the 'raw' information stored in the DICOM file: In case of\na series of multiple files, only the first file is considered.\nThe Image Orientation (Patient) is guaranteed to remain the same,\nand image Image Position (Patient) in other slice can be computed\nusing the ZSpacing (3rd dimension) (0020,0032) DS\n[87.774866\\-182.908510\\168.629671]       #  32, 3\nImagePositionPatient (0020,0037) DS\n[0.001479\\0.999989\\-0.004376\\-0.002039\\-0.004372\\-0.999988] # \n58, 6 ImageOrientationPatient\n"},
  {"GetCurve", PyvtkGDCMImageReader2_GetCurve, METH_VARARGS,
   "GetCurve(self) -> vtkPolyData\nC++: virtual vtkPolyData *GetCurve()\n\nSet/Get the first Curve Data:\n"},
  {"SetCurve", PyvtkGDCMImageReader2_SetCurve, METH_VARARGS,
   "SetCurve(self, pd:vtkPolyData) -> None\nC++: virtual void SetCurve(vtkPolyData *pd)\n\nSet/Get the first Curve Data:\n"},
  {"GetShift", PyvtkGDCMImageReader2_GetShift, METH_VARARGS,
   "GetShift(self) -> float\nC++: virtual double GetShift()\n\n\\DEPRECATED: Modality LUT Value returned by GetShift/GetScale\nmight be inaccurate since Shift/Scale could be varying along the\nSeries read. Therefore user are advices not to use those\nfunctions anymore\n"},
  {"GetScale", PyvtkGDCMImageReader2_GetScale, METH_VARARGS,
   "GetScale(self) -> float\nC++: virtual double GetScale()\n\n\\DEPRECATED: Modality LUT Value returned by GetShift/GetScale\nmight be inaccurate since Shift/Scale could be varying along the\nSeries read. Therefore user are advices not to use those\nfunctions anymore\n"},
  {nullptr, nullptr, 0, nullptr}
};

static const char *PyvtkGDCMImageReader2_Doc =
  "vtkGDCMImageReader2 - read DICOM Image files (Pixel Data)\n\n"
  "Superclass: vtkMedicalImageReader2\n\n"
  "vtkGDCMImageReader2 is a source object that reads some DICOM files\n"
  "this reader is single threaded.\n\n"
  "Implementation note: when FileLowerLeft is set to on the image is not flipped:\n\n"
  "upside down as VTK would expect, use this option only if you know\n"
  "what you are doing.\n\n"
  "Implementation note: when reading a series of 2D slices, user is:\n\n"
  "expected to provide an ordered list of filenames. No sorting will be\n"
  "applied afterward.\n\n"
  "Implementation note: Although 99% of the time the Zspacing as read:\n\n"
  "from a tag in a 2D DICOM file should be correct, there has been\n"
  "reports that this value can be missing, or incorrect, in which case\n"
  "users are advised to override this value using the return value from\n"
  "gdcm::IPPSorter::GetZSpacing() and set it via\n"
  "vtkImageChangeInformation on the reader itself.\n\n"
  "TODO:\n\n"
  "This reader does not handle a series of 3D images, only a single 3D\n"
  "(multi frame) or a list of 2D files are supported for now.\n\n"
  "TODO:\n\n"
  "Did not implement SetFilePattern / SetFilePrefix API, move it to\n"
  "protected section for now.\n\n"
  "BUG:\n\n"
  "Overlay are assumed to have the same extent as image. Right now if\n"
  "overlay origin is not 0,0 the overlay will have an offset... Only the\n"
  "very first overlay is loaded at the VTK level, for now (even if there\n"
  "are more than one in the file)\n\n"
  "DataOrigin:\n\n"
  "When the reader is instantiated with FileLowerLeftOn the DataOrigin\n"
  "and Image Position (Patient) are identical. But when FileLowerLeft is\n"
  "Off, we have to reorder the Y-line of the image, and thus the\n"
  "DataOrigin is then translated to the other side of the image.\n\n"
  "Spacing:\n\n"
  "When reading a 3D volume, the spacing along the Z dimension might be\n"
  "negative (so as to respect up-side-down) as specified in the Image\n"
  "Orientation (Patient) tag. When Z-spacing is 0, this means the\n"
  "multi-frame object contains image which do not represent uniform\n"
  "volume.\n\n"
  "Warning:\n\n"
  "When using vtkGDCMPolyDataReader in conjunction with\n"
  "vtkGDCMImageReader2 it is *required* that FileLowerLeft is set to ON\n"
  "as coordinate system would be inconsistent in between the two data\n"
  "structures.\n\n"
  "Color Space mapping:\n\n"
  "* VTK_LUMINANCE         <-> MONOCHROME2\n"
  "* VTK_LUMINANCE_ALPHA   <-> Not supported\n"
  "* VTK_RGB               <-> RGB\n"
  "* VTK_RGBA              <-> ARGB (deprecated, DICOM 2008)\n"
  "* VTK_INVERSE_LUMINANCE <-> MONOCHROME1\n"
  "* VTK_LOOKUP_TABLE      <-> PALETTE COLOR\n"
  "* VTK_YBR               <-> YBR_FULL\n\n"
  "For detailed information on color space transformation and true\n"
  "lossless transformation see:\n"
  "http://gdcm.sourceforge.net/wiki/index.php/Color_Space_Transformations\n\n"
  "See Also:\n\n"
  "vtkMedicalImageReader2 vtkMedicalImageProperties\n"
  "vtkGDCMPolyDataReader vtkGDCMImageWriter vtkDICOMImageReader\n\n";

#ifdef VTK_PYTHON_NEEDS_DEPRECATION_WARNING_SUPPRESSION
#pragma GCC diagnostic ignored "-Wdeprecated-declarations"
#endif

static PyTypeObject PyvtkGDCMImageReader2_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  PYTHON_PACKAGE_SCOPE "vtkgdcm.vtkGDCMImageReader2", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
#if PY_VERSION_HEX >= 0x03080000
  0, // tp_vectorcall_offset
#else
  nullptr, // tp_print
#endif
  nullptr, // tp_getattr
  nullptr, // tp_setattr
  nullptr, // tp_compare
  PyVTKObject_Repr, // tp_repr
  nullptr, // tp_as_number
  nullptr, // tp_as_sequence
  nullptr, // tp_as_mapping
  nullptr, // tp_hash
  nullptr, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  PyvtkGDCMImageReader2_Doc, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  nullptr, // tp_clear
  nullptr, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  nullptr, // tp_iter
  nullptr, // tp_iternext
  nullptr, // tp_methods
  nullptr, // tp_members
  PyVTKObject_GetSet, // tp_getset
  nullptr, // tp_base
  nullptr, // tp_dict
  nullptr, // tp_descr_get
  nullptr, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  nullptr, // tp_init
  nullptr, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  nullptr, // tp_is_gc
  nullptr, // tp_bases
  nullptr, // tp_mro
  nullptr, // tp_cache
  nullptr, // tp_subclasses
  nullptr, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkGDCMImageReader2_StaticNew()
{
  return vtkGDCMImageReader2::New();
}

PyObject *PyvtkGDCMImageReader2_ClassNew()
{
  PyTypeObject *pytype = PyVTKClass_Add(
    &PyvtkGDCMImageReader2_Type, PyvtkGDCMImageReader2_Methods,
    "vtkGDCMImageReader2",
 &PyvtkGDCMImageReader2_StaticNew);

  if ((PyType_GetFlags(pytype) & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

  pytype->tp_base = vtkPythonUtil::FindBaseTypeObject("vtkMedicalImageReader2");

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

void PyVTKAddFile_vtkGDCMImageReader2(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkGDCMImageReader2_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkGDCMImageReader2", o) != 0)
  {
    Py_DECREF(o);
  }

  for (int c = 0; c < 4; c++)
  {
    static const struct { const char *name; int value; }
      constants[4] = {
        { "VTK_INVERSE_LUMINANCE", 5 },
        { "VTK_LOOKUP_TABLE", 6 },
        { "VTK_YBR", 7 },
        { "VTK_CMYK", 8 },
      };

    o = PyLong_FromLong(constants[c].value);
    if (o)
    {
      PyDict_SetItemString(dict, constants[c].name, o);
      Py_DECREF(o);
    }
  }

}

