// python wrapper for vtkGDCMImageWriter
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkGDCMImageWriter.h"

#if defined(PYTHON_PACKAGE)
#define PYTHON_PACKAGE_SCOPE PYTHON_PACKAGE "."
#else
#define PYTHON_PACKAGE_SCOPE
#endif

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkGDCMImageWriter(PyObject *dict); }
extern "C" { PyObject *PyvtkGDCMImageWriter_ClassNew(); }

#ifdef VTK_PYTHON_NEEDS_DEPRECATION_WARNING_SUPPRESSION
#pragma GCC diagnostic ignored "-Wdeprecated-declarations"
#endif

static PyTypeObject PyvtkGDCMImageWriter_CompressionTypes_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  PYTHON_PACKAGE_SCOPE "vtkgdcm.vtkGDCMImageWriter.CompressionTypes", // tp_name
  sizeof(PyLongObject), // tp_basicsize
  0, // tp_itemsize
  nullptr, // tp_dealloc
#if PY_VERSION_HEX >= 0x03080000
  0, // tp_vectorcall_offset
#else
  nullptr, // tp_print
#endif
  nullptr, // tp_getattr
  nullptr, // tp_setattr
  nullptr, // tp_compare
  nullptr, // tp_repr
  nullptr, // tp_as_number
  nullptr, // tp_as_sequence
  nullptr, // tp_as_mapping
  nullptr, // tp_hash
  nullptr, // tp_call
  nullptr, // tp_str
  nullptr, // tp_getattro
  nullptr, // tp_setattro
  nullptr, // tp_as_buffer
  Py_TPFLAGS_DEFAULT
#if PY_VERSION_HEX >= 0x030A0000
    | Py_TPFLAGS_DISALLOW_INSTANTIATION
#endif
  , // tp_flags
  nullptr, // tp_doc
  nullptr, // tp_traverse
  nullptr, // tp_clear
  nullptr, // tp_richcompare
  0, // tp_weaklistoffset
  nullptr, // tp_iter
  nullptr, // tp_iternext
  nullptr, // tp_methods
  nullptr, // tp_members
  nullptr, // tp_getset
  &PyLong_Type, // tp_base
  nullptr, // tp_dict
  nullptr, // tp_descr_get
  nullptr, // tp_descr_set
  0, // tp_dictoffset
  nullptr, // tp_init
  nullptr, // tp_alloc
  nullptr, // tp_new
  PyObject_Del, // tp_free
  nullptr, // tp_is_gc
  nullptr, // tp_bases
  nullptr, // tp_mro
  nullptr, // tp_cache
  nullptr, // tp_subclasses
  nullptr, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

template<class T>
PyObject *PyvtkGDCMImageWriter_CompressionTypes_FromEnum(T val)
{
  return PyVTKEnum_New(&PyvtkGDCMImageWriter_CompressionTypes_Type, static_cast<int>(val));
}


static PyObject *
PyvtkGDCMImageWriter_IsTypeOf(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkGDCMImageWriter::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGDCMImageWriter_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGDCMImageWriter *op = static_cast<vtkGDCMImageWriter *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkGDCMImageWriter::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGDCMImageWriter_SafeDownCast(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkGDCMImageWriter *tempr = vtkGDCMImageWriter::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGDCMImageWriter_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGDCMImageWriter *op = static_cast<vtkGDCMImageWriter *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkGDCMImageWriter *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkGDCMImageWriter::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(nullptr);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
    else if (tempr != nullptr)
    {
      ap.DeleteVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGDCMImageWriter_GetNumberOfGenerationsFromBaseType(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "GetNumberOfGenerationsFromBaseType");

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    long long tempr = vtkGDCMImageWriter::GetNumberOfGenerationsFromBaseType(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGDCMImageWriter_GetNumberOfGenerationsFromBase(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNumberOfGenerationsFromBase");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGDCMImageWriter *op = static_cast<vtkGDCMImageWriter *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    long long tempr = (ap.IsBound() ?
      op->GetNumberOfGenerationsFromBase(temp0) :
      op->vtkGDCMImageWriter::GetNumberOfGenerationsFromBase(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGDCMImageWriter_GetMedicalImageProperties(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetMedicalImageProperties");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGDCMImageWriter *op = static_cast<vtkGDCMImageWriter *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkMedicalImageProperties *tempr = (ap.IsBound() ?
      op->GetMedicalImageProperties() :
      op->vtkGDCMImageWriter::GetMedicalImageProperties());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGDCMImageWriter_SetMedicalImageProperties(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetMedicalImageProperties");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGDCMImageWriter *op = static_cast<vtkGDCMImageWriter *>(vp);

  vtkMedicalImageProperties *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkMedicalImageProperties"))
  {
    if (ap.IsBound())
    {
      op->SetMedicalImageProperties(temp0);
    }
    else
    {
      op->vtkGDCMImageWriter::SetMedicalImageProperties(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGDCMImageWriter_SetFileNames(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetFileNames");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGDCMImageWriter *op = static_cast<vtkGDCMImageWriter *>(vp);

  vtkStringArray *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkStringArray"))
  {
    if (ap.IsBound())
    {
      op->SetFileNames(temp0);
    }
    else
    {
      op->vtkGDCMImageWriter::SetFileNames(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGDCMImageWriter_GetFileNames(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetFileNames");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGDCMImageWriter *op = static_cast<vtkGDCMImageWriter *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkStringArray *tempr = (ap.IsBound() ?
      op->GetFileNames() :
      op->vtkGDCMImageWriter::GetFileNames());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGDCMImageWriter_GetLossyFlag(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetLossyFlag");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGDCMImageWriter *op = static_cast<vtkGDCMImageWriter *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetLossyFlag() :
      op->vtkGDCMImageWriter::GetLossyFlag());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGDCMImageWriter_SetLossyFlag(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetLossyFlag");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGDCMImageWriter *op = static_cast<vtkGDCMImageWriter *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetLossyFlag(temp0);
    }
    else
    {
      op->vtkGDCMImageWriter::SetLossyFlag(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGDCMImageWriter_LossyFlagOn(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "LossyFlagOn");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGDCMImageWriter *op = static_cast<vtkGDCMImageWriter *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->LossyFlagOn();
    }
    else
    {
      op->vtkGDCMImageWriter::LossyFlagOn();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGDCMImageWriter_LossyFlagOff(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "LossyFlagOff");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGDCMImageWriter *op = static_cast<vtkGDCMImageWriter *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->LossyFlagOff();
    }
    else
    {
      op->vtkGDCMImageWriter::LossyFlagOff();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGDCMImageWriter_Write(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Write");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGDCMImageWriter *op = static_cast<vtkGDCMImageWriter *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->Write();
    }
    else
    {
      op->vtkGDCMImageWriter::Write();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGDCMImageWriter_GetFileExtensions(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetFileExtensions");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGDCMImageWriter *op = static_cast<vtkGDCMImageWriter *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetFileExtensions() :
      op->vtkGDCMImageWriter::GetFileExtensions());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGDCMImageWriter_GetDescriptiveName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetDescriptiveName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGDCMImageWriter *op = static_cast<vtkGDCMImageWriter *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetDescriptiveName() :
      op->vtkGDCMImageWriter::GetDescriptiveName());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGDCMImageWriter_SetDirectionCosines(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetDirectionCosines");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGDCMImageWriter *op = static_cast<vtkGDCMImageWriter *>(vp);

  vtkMatrix4x4 *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkMatrix4x4"))
  {
    if (ap.IsBound())
    {
      op->SetDirectionCosines(temp0);
    }
    else
    {
      op->vtkGDCMImageWriter::SetDirectionCosines(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGDCMImageWriter_GetDirectionCosines(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetDirectionCosines");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGDCMImageWriter *op = static_cast<vtkGDCMImageWriter *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkMatrix4x4 *tempr = (ap.IsBound() ?
      op->GetDirectionCosines() :
      op->vtkGDCMImageWriter::GetDirectionCosines());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGDCMImageWriter_SetDirectionCosinesFromImageOrientationPatient(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetDirectionCosinesFromImageOrientationPatient");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGDCMImageWriter *op = static_cast<vtkGDCMImageWriter *>(vp);

  const size_t size0 = 6;
  double temp0[6];
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetArray(temp0, size0))
  {
    if (ap.IsBound())
    {
      op->SetDirectionCosinesFromImageOrientationPatient(temp0);
    }
    else
    {
      op->vtkGDCMImageWriter::SetDirectionCosinesFromImageOrientationPatient(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGDCMImageWriter_SetShift(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetShift");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGDCMImageWriter *op = static_cast<vtkGDCMImageWriter *>(vp);

  double temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetShift(temp0);
    }
    else
    {
      op->vtkGDCMImageWriter::SetShift(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGDCMImageWriter_GetShift(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetShift");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGDCMImageWriter *op = static_cast<vtkGDCMImageWriter *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    double tempr = (ap.IsBound() ?
      op->GetShift() :
      op->vtkGDCMImageWriter::GetShift());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGDCMImageWriter_SetScale(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetScale");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGDCMImageWriter *op = static_cast<vtkGDCMImageWriter *>(vp);

  double temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetScale(temp0);
    }
    else
    {
      op->vtkGDCMImageWriter::SetScale(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGDCMImageWriter_GetScale(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetScale");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGDCMImageWriter *op = static_cast<vtkGDCMImageWriter *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    double tempr = (ap.IsBound() ?
      op->GetScale() :
      op->vtkGDCMImageWriter::GetScale());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGDCMImageWriter_GetImageFormat(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetImageFormat");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGDCMImageWriter *op = static_cast<vtkGDCMImageWriter *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetImageFormat() :
      op->vtkGDCMImageWriter::GetImageFormat());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGDCMImageWriter_SetImageFormat(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetImageFormat");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGDCMImageWriter *op = static_cast<vtkGDCMImageWriter *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetImageFormat(temp0);
    }
    else
    {
      op->vtkGDCMImageWriter::SetImageFormat(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGDCMImageWriter_FileLowerLeftOn(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "FileLowerLeftOn");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGDCMImageWriter *op = static_cast<vtkGDCMImageWriter *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->FileLowerLeftOn();
    }
    else
    {
      op->vtkGDCMImageWriter::FileLowerLeftOn();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGDCMImageWriter_FileLowerLeftOff(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "FileLowerLeftOff");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGDCMImageWriter *op = static_cast<vtkGDCMImageWriter *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->FileLowerLeftOff();
    }
    else
    {
      op->vtkGDCMImageWriter::FileLowerLeftOff();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGDCMImageWriter_GetFileLowerLeft(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetFileLowerLeft");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGDCMImageWriter *op = static_cast<vtkGDCMImageWriter *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetFileLowerLeft() :
      op->vtkGDCMImageWriter::GetFileLowerLeft());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGDCMImageWriter_SetFileLowerLeft(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetFileLowerLeft");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGDCMImageWriter *op = static_cast<vtkGDCMImageWriter *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetFileLowerLeft(temp0);
    }
    else
    {
      op->vtkGDCMImageWriter::SetFileLowerLeft(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGDCMImageWriter_SetPlanarConfiguration(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetPlanarConfiguration");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGDCMImageWriter *op = static_cast<vtkGDCMImageWriter *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetPlanarConfiguration(temp0);
    }
    else
    {
      op->vtkGDCMImageWriter::SetPlanarConfiguration(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGDCMImageWriter_GetPlanarConfiguration(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetPlanarConfiguration");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGDCMImageWriter *op = static_cast<vtkGDCMImageWriter *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetPlanarConfiguration() :
      op->vtkGDCMImageWriter::GetPlanarConfiguration());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGDCMImageWriter_SetStudyUID(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetStudyUID");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGDCMImageWriter *op = static_cast<vtkGDCMImageWriter *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetStudyUID(temp0);
    }
    else
    {
      op->vtkGDCMImageWriter::SetStudyUID(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGDCMImageWriter_GetStudyUID(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetStudyUID");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGDCMImageWriter *op = static_cast<vtkGDCMImageWriter *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    char *tempr = (ap.IsBound() ?
      op->GetStudyUID() :
      op->vtkGDCMImageWriter::GetStudyUID());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGDCMImageWriter_SetSeriesUID(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetSeriesUID");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGDCMImageWriter *op = static_cast<vtkGDCMImageWriter *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetSeriesUID(temp0);
    }
    else
    {
      op->vtkGDCMImageWriter::SetSeriesUID(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGDCMImageWriter_GetSeriesUID(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetSeriesUID");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGDCMImageWriter *op = static_cast<vtkGDCMImageWriter *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    char *tempr = (ap.IsBound() ?
      op->GetSeriesUID() :
      op->vtkGDCMImageWriter::GetSeriesUID());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGDCMImageWriter_SetCompressionType(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetCompressionType");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGDCMImageWriter *op = static_cast<vtkGDCMImageWriter *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetCompressionType(temp0);
    }
    else
    {
      op->vtkGDCMImageWriter::SetCompressionType(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGDCMImageWriter_GetCompressionType(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetCompressionType");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGDCMImageWriter *op = static_cast<vtkGDCMImageWriter *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetCompressionType() :
      op->vtkGDCMImageWriter::GetCompressionType());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkGDCMImageWriter_Methods[] = {
  {"IsTypeOf", PyvtkGDCMImageWriter_IsTypeOf, METH_VARARGS,
   "IsTypeOf(type:str) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\nReturn 1 if this class type is the same type of (or a subclass\nof) the named class. Returns 0 otherwise. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"IsA", PyvtkGDCMImageWriter_IsA, METH_VARARGS,
   "IsA(self, type:str) -> int\nC++: vtkTypeBool IsA(const char *type) override;\n\nReturn 1 if this class is the same type of (or a subclass of) the\nnamed class. Returns 0 otherwise. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"SafeDownCast", PyvtkGDCMImageWriter_SafeDownCast, METH_VARARGS,
   "SafeDownCast(o:vtkObjectBase) -> vtkGDCMImageWriter\nC++: static vtkGDCMImageWriter *SafeDownCast(vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkGDCMImageWriter_NewInstance, METH_VARARGS,
   "NewInstance(self) -> vtkGDCMImageWriter\nC++: vtkGDCMImageWriter *NewInstance()\n\n"},
  {"GetNumberOfGenerationsFromBaseType", PyvtkGDCMImageWriter_GetNumberOfGenerationsFromBaseType, METH_VARARGS,
   "GetNumberOfGenerationsFromBaseType(type:str) -> int\nC++: static vtkIdType GetNumberOfGenerationsFromBaseType(\n    const char *type)\n\nGiven a the name of a base class of this class type, return the\ndistance of inheritance between this class type and the named\nclass (how many generations of inheritance are there between this\nclass and the named class). If the named class is not in this\nclass's inheritance tree, return a negative value. Valid\nresponses will always be nonnegative. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"GetNumberOfGenerationsFromBase", PyvtkGDCMImageWriter_GetNumberOfGenerationsFromBase, METH_VARARGS,
   "GetNumberOfGenerationsFromBase(self, type:str) -> int\nC++: vtkIdType GetNumberOfGenerationsFromBase(const char *type)\n    override;\n\nGiven the name of a base class of this class type, return the\ndistance of inheritance between this class type and the named\nclass (how many generations of inheritance are there between this\nclass and the named class). If the named class is not in this\nclass's inheritance tree, return a negative value. Valid\nresponses will always be nonnegative. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"GetMedicalImageProperties", PyvtkGDCMImageWriter_GetMedicalImageProperties, METH_VARARGS,
   "GetMedicalImageProperties(self) -> vtkMedicalImageProperties\nC++: virtual vtkMedicalImageProperties *GetMedicalImageProperties(\n    )\n\nPass in the vtkmedicalimageproperties object for medical\ninformation to be mapped to DICOM attributes.\n"},
  {"SetMedicalImageProperties", PyvtkGDCMImageWriter_SetMedicalImageProperties, METH_VARARGS,
   "SetMedicalImageProperties(self, __a:vtkMedicalImageProperties)\n    -> None\nC++: virtual void SetMedicalImageProperties(\n    vtkMedicalImageProperties *)\n\nPass in the vtkmedicalimageproperties object for medical\ninformation to be mapped to DICOM attributes.\n"},
  {"SetFileNames", PyvtkGDCMImageWriter_SetFileNames, METH_VARARGS,
   "SetFileNames(self, __a:vtkStringArray) -> None\nC++: virtual void SetFileNames(vtkStringArray *)\n\nPass in the list of filename to be used to write out the DICOM\nfile(s)\n"},
  {"GetFileNames", PyvtkGDCMImageWriter_GetFileNames, METH_VARARGS,
   "GetFileNames(self) -> vtkStringArray\nC++: virtual vtkStringArray *GetFileNames()\n\nPass in the list of filename to be used to write out the DICOM\nfile(s)\n"},
  {"GetLossyFlag", PyvtkGDCMImageWriter_GetLossyFlag, METH_VARARGS,
   "GetLossyFlag(self) -> int\nC++: virtual int GetLossyFlag()\n\nSet/Get whether or not the image was compressed using a lossy\ncompression algorithm\n"},
  {"SetLossyFlag", PyvtkGDCMImageWriter_SetLossyFlag, METH_VARARGS,
   "SetLossyFlag(self, _arg:int) -> None\nC++: virtual void SetLossyFlag(int _arg)\n\nSet/Get whether or not the image was compressed using a lossy\ncompression algorithm\n"},
  {"LossyFlagOn", PyvtkGDCMImageWriter_LossyFlagOn, METH_VARARGS,
   "LossyFlagOn(self) -> None\nC++: virtual void LossyFlagOn()\n\nSet/Get whether or not the image was compressed using a lossy\ncompression algorithm\n"},
  {"LossyFlagOff", PyvtkGDCMImageWriter_LossyFlagOff, METH_VARARGS,
   "LossyFlagOff(self) -> None\nC++: virtual void LossyFlagOff()\n\nSet/Get whether or not the image was compressed using a lossy\ncompression algorithm\n"},
  {"Write", PyvtkGDCMImageWriter_Write, METH_VARARGS,
   "Write(self) -> None\nC++: virtual void Write()\n\nThe main interface which triggers the writer to start.\n"},
  {"GetFileExtensions", PyvtkGDCMImageWriter_GetFileExtensions, METH_VARARGS,
   "GetFileExtensions(self) -> str\nC++: virtual const char *GetFileExtensions()\n\nGet the extension for this file format.\n"},
  {"GetDescriptiveName", PyvtkGDCMImageWriter_GetDescriptiveName, METH_VARARGS,
   "GetDescriptiveName(self) -> str\nC++: virtual const char *GetDescriptiveName()\n\nGet the name of this file format.\n"},
  {"SetDirectionCosines", PyvtkGDCMImageWriter_SetDirectionCosines, METH_VARARGS,
   "SetDirectionCosines(self, matrix:vtkMatrix4x4) -> None\nC++: virtual void SetDirectionCosines(vtkMatrix4x4 *matrix)\n\nYou need to manually specify the direction the image is in to\nwrite a valid DICOM file since vtkImageData do not contains one\n(eg. MR Image Storage, CT Image Storage...)\n"},
  {"GetDirectionCosines", PyvtkGDCMImageWriter_GetDirectionCosines, METH_VARARGS,
   "GetDirectionCosines(self) -> vtkMatrix4x4\nC++: virtual vtkMatrix4x4 *GetDirectionCosines()\n\nYou need to manually specify the direction the image is in to\nwrite a valid DICOM file since vtkImageData do not contains one\n(eg. MR Image Storage, CT Image Storage...)\n"},
  {"SetDirectionCosinesFromImageOrientationPatient", PyvtkGDCMImageWriter_SetDirectionCosinesFromImageOrientationPatient, METH_VARARGS,
   "SetDirectionCosinesFromImageOrientationPatient(self, dircos:(\n    float, float, float, float, float, float)) -> None\nC++: virtual void SetDirectionCosinesFromImageOrientationPatient(\n    const double dircos[6])\n\nYou need to manually specify the direction the image is in to\nwrite a valid DICOM file since vtkImageData do not contains one\n(eg. MR Image Storage, CT Image Storage...)\n"},
  {"SetShift", PyvtkGDCMImageWriter_SetShift, METH_VARARGS,
   "SetShift(self, _arg:float) -> None\nC++: virtual void SetShift(double _arg)\n\nModality LUT\n"},
  {"GetShift", PyvtkGDCMImageWriter_GetShift, METH_VARARGS,
   "GetShift(self) -> float\nC++: virtual double GetShift()\n\nModality LUT\n"},
  {"SetScale", PyvtkGDCMImageWriter_SetScale, METH_VARARGS,
   "SetScale(self, _arg:float) -> None\nC++: virtual void SetScale(double _arg)\n\nModality LUT\n"},
  {"GetScale", PyvtkGDCMImageWriter_GetScale, METH_VARARGS,
   "GetScale(self) -> float\nC++: virtual double GetScale()\n\nModality LUT\n"},
  {"GetImageFormat", PyvtkGDCMImageWriter_GetImageFormat, METH_VARARGS,
   "GetImageFormat(self) -> int\nC++: virtual int GetImageFormat()\n\nSee vtkGDCMImageReader for list of ImageFormat\n"},
  {"SetImageFormat", PyvtkGDCMImageWriter_SetImageFormat, METH_VARARGS,
   "SetImageFormat(self, _arg:int) -> None\nC++: virtual void SetImageFormat(int _arg)\n\nSee vtkGDCMImageReader for list of ImageFormat\n"},
  {"FileLowerLeftOn", PyvtkGDCMImageWriter_FileLowerLeftOn, METH_VARARGS,
   "FileLowerLeftOn(self) -> None\nC++: virtual void FileLowerLeftOn()\n\nSet/Get whether the data comes from the file starting in the\nlower left corner or upper left corner.\n"},
  {"FileLowerLeftOff", PyvtkGDCMImageWriter_FileLowerLeftOff, METH_VARARGS,
   "FileLowerLeftOff(self) -> None\nC++: virtual void FileLowerLeftOff()\n\nSet/Get whether the data comes from the file starting in the\nlower left corner or upper left corner.\n"},
  {"GetFileLowerLeft", PyvtkGDCMImageWriter_GetFileLowerLeft, METH_VARARGS,
   "GetFileLowerLeft(self) -> int\nC++: virtual int GetFileLowerLeft()\n\nSet/Get whether the data comes from the file starting in the\nlower left corner or upper left corner.\n"},
  {"SetFileLowerLeft", PyvtkGDCMImageWriter_SetFileLowerLeft, METH_VARARGS,
   "SetFileLowerLeft(self, _arg:int) -> None\nC++: virtual void SetFileLowerLeft(int _arg)\n\nSet/Get whether the data comes from the file starting in the\nlower left corner or upper left corner.\n"},
  {"SetPlanarConfiguration", PyvtkGDCMImageWriter_SetPlanarConfiguration, METH_VARARGS,
   "SetPlanarConfiguration(self, _arg:int) -> None\nC++: virtual void SetPlanarConfiguration(int _arg)\n\nFor color image (more than a single comp) you can specify the\nplanar configuration you prefer\n"},
  {"GetPlanarConfiguration", PyvtkGDCMImageWriter_GetPlanarConfiguration, METH_VARARGS,
   "GetPlanarConfiguration(self) -> int\nC++: virtual int GetPlanarConfiguration()\n\nFor color image (more than a single comp) you can specify the\nplanar configuration you prefer\n"},
  {"SetStudyUID", PyvtkGDCMImageWriter_SetStudyUID, METH_VARARGS,
   "SetStudyUID(self, _arg:str) -> None\nC++: virtual void SetStudyUID(const char *_arg)\n\nSet/Get specific StudyUID / SeriesUID\n"},
  {"GetStudyUID", PyvtkGDCMImageWriter_GetStudyUID, METH_VARARGS,
   "GetStudyUID(self) -> str\nC++: virtual char *GetStudyUID()\n\nSet/Get specific StudyUID / SeriesUID\n"},
  {"SetSeriesUID", PyvtkGDCMImageWriter_SetSeriesUID, METH_VARARGS,
   "SetSeriesUID(self, _arg:str) -> None\nC++: virtual void SetSeriesUID(const char *_arg)\n\nSet/Get specific StudyUID / SeriesUID\n"},
  {"GetSeriesUID", PyvtkGDCMImageWriter_GetSeriesUID, METH_VARARGS,
   "GetSeriesUID(self) -> str\nC++: virtual char *GetSeriesUID()\n\nSet/Get specific StudyUID / SeriesUID\n"},
  {"SetCompressionType", PyvtkGDCMImageWriter_SetCompressionType, METH_VARARGS,
   "SetCompressionType(self, _arg:int) -> None\nC++: virtual void SetCompressionType(int _arg)\n\n"},
  {"GetCompressionType", PyvtkGDCMImageWriter_GetCompressionType, METH_VARARGS,
   "GetCompressionType(self) -> int\nC++: virtual int GetCompressionType()\n\n"},
  {nullptr, nullptr, 0, nullptr}
};

static const char *PyvtkGDCMImageWriter_Doc =
  "vtkGDCMImageWriter - write DICOM files\n\n"
  "Superclass: vtkImageWriter\n\n"
  "vtkGDCMImageWriter is a sink object that write DICOM files this\n"
  "writer is single threaded (see vtkGDCMThreadedImageReader2 for\n"
  "multi-thread)\n\n"
  "Warning: vtkLookupTable from the vtkImageData object taken into account:\n\n"
  "only if ImageFormat is set to VTK_LOOKUP_TABLE\n\n"
  "NOTE We are not using the usual API SetFilePrefix / SetFilePattern,:\n\n"
  "but instead a list of filenames: see SetFileNames and class\n"
  "gdcm::FilenameGenerator\n\n"
  "Warning:\n\n"
  "You need to specify the correct ImageFormat (taken from the reader)\n"
  "You need to explicitly specify the DirectionCosines (taken from the\n"
  "reader) Since VTK 5.4 vtkMedicalImageProperties has its own\n"
  "DirectionCosine (no 's') user need to make sure the vtkMatrix4x4 is\n"
  "compatible with the 6-vector DirectionCosine.\n\n"
  "NOTE Shift/Scale are global to all DICOM frames (=files) written:\n\n"
  "as 2D slice, therefore the shift/scale operation might not be\n"
  "optimized for all slices. This is not recommended for image with a\n"
  "large dynamic range.\n\n"
  "See Also:\n\n"
  "vtkImageWriter vtkMedicalImageProperties vtkGDCMImageReader\n\n";

#ifdef VTK_PYTHON_NEEDS_DEPRECATION_WARNING_SUPPRESSION
#pragma GCC diagnostic ignored "-Wdeprecated-declarations"
#endif

static PyTypeObject PyvtkGDCMImageWriter_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  PYTHON_PACKAGE_SCOPE "vtkgdcm.vtkGDCMImageWriter", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
#if PY_VERSION_HEX >= 0x03080000
  0, // tp_vectorcall_offset
#else
  nullptr, // tp_print
#endif
  nullptr, // tp_getattr
  nullptr, // tp_setattr
  nullptr, // tp_compare
  PyVTKObject_Repr, // tp_repr
  nullptr, // tp_as_number
  nullptr, // tp_as_sequence
  nullptr, // tp_as_mapping
  nullptr, // tp_hash
  nullptr, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  PyvtkGDCMImageWriter_Doc, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  nullptr, // tp_clear
  nullptr, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  nullptr, // tp_iter
  nullptr, // tp_iternext
  nullptr, // tp_methods
  nullptr, // tp_members
  PyVTKObject_GetSet, // tp_getset
  nullptr, // tp_base
  nullptr, // tp_dict
  nullptr, // tp_descr_get
  nullptr, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  nullptr, // tp_init
  nullptr, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  nullptr, // tp_is_gc
  nullptr, // tp_bases
  nullptr, // tp_mro
  nullptr, // tp_cache
  nullptr, // tp_subclasses
  nullptr, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkGDCMImageWriter_StaticNew()
{
  return vtkGDCMImageWriter::New();
}

PyObject *PyvtkGDCMImageWriter_ClassNew()
{
  PyTypeObject *pytype = PyVTKClass_Add(
    &PyvtkGDCMImageWriter_Type, PyvtkGDCMImageWriter_Methods,
    "vtkGDCMImageWriter",
 &PyvtkGDCMImageWriter_StaticNew);

  if ((PyType_GetFlags(pytype) & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

  pytype->tp_base = vtkPythonUtil::FindBaseTypeObject("vtkImageWriter");

  PyObject *d = pytype->tp_dict;
  PyObject *o;

  PyType_Ready(&PyvtkGDCMImageWriter_CompressionTypes_Type);
  PyVTKEnum_Add(&PyvtkGDCMImageWriter_CompressionTypes_Type, "vtkGDCMImageWriter.CompressionTypes");

  o = (PyObject *)&PyvtkGDCMImageWriter_CompressionTypes_Type;
  if (PyDict_SetItemString(d, "CompressionTypes", o) != 0)
  {
    Py_DECREF(o);
  }

  for (int c = 0; c < 5; c++)
  {
    typedef vtkGDCMImageWriter::CompressionTypes cxx_enum_type;

    static const struct { const char *name; cxx_enum_type value; }
      constants[5] = {
        { "NO_COMPRESSION", vtkGDCMImageWriter::NO_COMPRESSION },
        { "JPEG_COMPRESSION", vtkGDCMImageWriter::JPEG_COMPRESSION },
        { "JPEG2000_COMPRESSION", vtkGDCMImageWriter::JPEG2000_COMPRESSION },
        { "JPEGLS_COMPRESSION", vtkGDCMImageWriter::JPEGLS_COMPRESSION },
        { "RLE_COMPRESSION", vtkGDCMImageWriter::RLE_COMPRESSION },
      };

    o = PyvtkGDCMImageWriter_CompressionTypes_FromEnum(constants[c].value);
    if (o)
    {
      PyDict_SetItemString(d, constants[c].name, o);
      Py_DECREF(o);
    }
  }

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

void PyVTKAddFile_vtkGDCMImageWriter(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkGDCMImageWriter_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkGDCMImageWriter", o) != 0)
  {
    Py_DECREF(o);
  }

}

