// python wrapper for vtkGDCMPolyDataWriter
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkStdString.h"
#include "vtkGDCMPolyDataWriter.h"

#if defined(PYTHON_PACKAGE)
#define PYTHON_PACKAGE_SCOPE PYTHON_PACKAGE "."
#else
#define PYTHON_PACKAGE_SCOPE
#endif

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkGDCMPolyDataWriter(PyObject *dict); }
extern "C" { PyObject *PyvtkGDCMPolyDataWriter_ClassNew(); }


static PyObject *
PyvtkGDCMPolyDataWriter_IsTypeOf(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkGDCMPolyDataWriter::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGDCMPolyDataWriter_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGDCMPolyDataWriter *op = static_cast<vtkGDCMPolyDataWriter *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkGDCMPolyDataWriter::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGDCMPolyDataWriter_SafeDownCast(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkGDCMPolyDataWriter *tempr = vtkGDCMPolyDataWriter::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGDCMPolyDataWriter_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGDCMPolyDataWriter *op = static_cast<vtkGDCMPolyDataWriter *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkGDCMPolyDataWriter *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkGDCMPolyDataWriter::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(nullptr);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
    else if (tempr != nullptr)
    {
      ap.DeleteVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGDCMPolyDataWriter_GetNumberOfGenerationsFromBaseType(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "GetNumberOfGenerationsFromBaseType");

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    long long tempr = vtkGDCMPolyDataWriter::GetNumberOfGenerationsFromBaseType(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGDCMPolyDataWriter_GetNumberOfGenerationsFromBase(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNumberOfGenerationsFromBase");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGDCMPolyDataWriter *op = static_cast<vtkGDCMPolyDataWriter *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    long long tempr = (ap.IsBound() ?
      op->GetNumberOfGenerationsFromBase(temp0) :
      op->vtkGDCMPolyDataWriter::GetNumberOfGenerationsFromBase(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGDCMPolyDataWriter_SetMedicalImageProperties(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetMedicalImageProperties");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGDCMPolyDataWriter *op = static_cast<vtkGDCMPolyDataWriter *>(vp);

  vtkMedicalImageProperties *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkMedicalImageProperties"))
  {
    if (ap.IsBound())
    {
      op->SetMedicalImageProperties(temp0);
    }
    else
    {
      op->vtkGDCMPolyDataWriter::SetMedicalImageProperties(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGDCMPolyDataWriter_SetRTStructSetProperties(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetRTStructSetProperties");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGDCMPolyDataWriter *op = static_cast<vtkGDCMPolyDataWriter *>(vp);

  vtkRTStructSetProperties *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkRTStructSetProperties"))
  {
    if (ap.IsBound())
    {
      op->SetRTStructSetProperties(temp0);
    }
    else
    {
      op->vtkGDCMPolyDataWriter::SetRTStructSetProperties(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGDCMPolyDataWriter_InitializeRTStructSet(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "InitializeRTStructSet");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGDCMPolyDataWriter *op = static_cast<vtkGDCMPolyDataWriter *>(vp);

  vtkStdString temp0;
  vtkStdString temp1;
  vtkStdString temp2;
  vtkStringArray *temp3 = nullptr;
  vtkStringArray *temp4 = nullptr;
  vtkStringArray *temp5 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(6) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1) &&
      ap.GetValue(temp2) &&
      ap.GetVTKObject(temp3, "vtkStringArray") &&
      ap.GetVTKObject(temp4, "vtkStringArray") &&
      ap.GetVTKObject(temp5, "vtkStringArray"))
  {
    if (ap.IsBound())
    {
      op->InitializeRTStructSet(temp0, temp1, temp2, temp3, temp4, temp5);
    }
    else
    {
      op->vtkGDCMPolyDataWriter::InitializeRTStructSet(temp0, temp1, temp2, temp3, temp4, temp5);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGDCMPolyDataWriter_SetNumberOfInputPorts(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetNumberOfInputPorts");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGDCMPolyDataWriter *op = static_cast<vtkGDCMPolyDataWriter *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetNumberOfInputPorts(temp0);
    }
    else
    {
      op->vtkGDCMPolyDataWriter::SetNumberOfInputPorts(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyMethodDef PyvtkGDCMPolyDataWriter_Methods[] = {
  {"IsTypeOf", PyvtkGDCMPolyDataWriter_IsTypeOf, METH_VARARGS,
   "IsTypeOf(type:str) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\nReturn 1 if this class type is the same type of (or a subclass\nof) the named class. Returns 0 otherwise. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"IsA", PyvtkGDCMPolyDataWriter_IsA, METH_VARARGS,
   "IsA(self, type:str) -> int\nC++: vtkTypeBool IsA(const char *type) override;\n\nReturn 1 if this class is the same type of (or a subclass of) the\nnamed class. Returns 0 otherwise. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"SafeDownCast", PyvtkGDCMPolyDataWriter_SafeDownCast, METH_VARARGS,
   "SafeDownCast(o:vtkObjectBase) -> vtkGDCMPolyDataWriter\nC++: static vtkGDCMPolyDataWriter *SafeDownCast(vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkGDCMPolyDataWriter_NewInstance, METH_VARARGS,
   "NewInstance(self) -> vtkGDCMPolyDataWriter\nC++: vtkGDCMPolyDataWriter *NewInstance()\n\n"},
  {"GetNumberOfGenerationsFromBaseType", PyvtkGDCMPolyDataWriter_GetNumberOfGenerationsFromBaseType, METH_VARARGS,
   "GetNumberOfGenerationsFromBaseType(type:str) -> int\nC++: static vtkIdType GetNumberOfGenerationsFromBaseType(\n    const char *type)\n\nGiven a the name of a base class of this class type, return the\ndistance of inheritance between this class type and the named\nclass (how many generations of inheritance are there between this\nclass and the named class). If the named class is not in this\nclass's inheritance tree, return a negative value. Valid\nresponses will always be nonnegative. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"GetNumberOfGenerationsFromBase", PyvtkGDCMPolyDataWriter_GetNumberOfGenerationsFromBase, METH_VARARGS,
   "GetNumberOfGenerationsFromBase(self, type:str) -> int\nC++: vtkIdType GetNumberOfGenerationsFromBase(const char *type)\n    override;\n\nGiven the name of a base class of this class type, return the\ndistance of inheritance between this class type and the named\nclass (how many generations of inheritance are there between this\nclass and the named class). If the named class is not in this\nclass's inheritance tree, return a negative value. Valid\nresponses will always be nonnegative. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"SetMedicalImageProperties", PyvtkGDCMPolyDataWriter_SetMedicalImageProperties, METH_VARARGS,
   "SetMedicalImageProperties(self, pd:vtkMedicalImageProperties)\n    -> None\nC++: virtual void SetMedicalImageProperties(\n    vtkMedicalImageProperties *pd)\n\nGet the medical image properties object\n vtkGetObjectMacro(MedicalImageProperties,\nvtkMedicalImageProperties);\n"},
  {"SetRTStructSetProperties", PyvtkGDCMPolyDataWriter_SetRTStructSetProperties, METH_VARARGS,
   "SetRTStructSetProperties(self, pd:vtkRTStructSetProperties)\n    -> None\nC++: virtual void SetRTStructSetProperties(\n    vtkRTStructSetProperties *pd)\n\n"},
  {"InitializeRTStructSet", PyvtkGDCMPolyDataWriter_InitializeRTStructSet, METH_VARARGS,
   "InitializeRTStructSet(self, inDirectory:str, inStructLabel:str,\n    inStructName:str, inROINames:vtkStringArray,\n    inROIAlgorithmName:vtkStringArray, inROIType:vtkStringArray)\n    -> None\nC++: void InitializeRTStructSet(vtkStdString inDirectory,\n    vtkStdString inStructLabel, vtkStdString inStructName,\n    vtkStringArray *inROINames,\n    vtkStringArray *inROIAlgorithmName, vtkStringArray *inROIType)\n\n"},
  {"SetNumberOfInputPorts", PyvtkGDCMPolyDataWriter_SetNumberOfInputPorts, METH_VARARGS,
   "SetNumberOfInputPorts(self, n:int) -> None\nC++: void SetNumberOfInputPorts(int n)\n\nSet the number of input ports used by the algorithm.\n"},
  {nullptr, nullptr, 0, nullptr}
};

static const char *PyvtkGDCMPolyDataWriter_Doc =
  "vtkGDCMPolyDataWriter - writer DICOM PolyData files (Contour Data...)\n\n"
  "Superclass: vtkPolyDataWriter\n\n"
  "For now only support RTSTRUCT (RT Structure Set Storage)\n\n"
  "TODO:\n\n"
  "Need to do the same job for DVH Sequence/DVH Data...\n\n"
  "Warning:\n\n"
  "See Also:\n\n"
  "vtkGDCMImageReader vtkGDCMPolyDataReader vtkRTStructSetProperties\n\n";

#ifdef VTK_PYTHON_NEEDS_DEPRECATION_WARNING_SUPPRESSION
#pragma GCC diagnostic ignored "-Wdeprecated-declarations"
#endif

static PyTypeObject PyvtkGDCMPolyDataWriter_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  PYTHON_PACKAGE_SCOPE "vtkgdcm.vtkGDCMPolyDataWriter", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
#if PY_VERSION_HEX >= 0x03080000
  0, // tp_vectorcall_offset
#else
  nullptr, // tp_print
#endif
  nullptr, // tp_getattr
  nullptr, // tp_setattr
  nullptr, // tp_compare
  PyVTKObject_Repr, // tp_repr
  nullptr, // tp_as_number
  nullptr, // tp_as_sequence
  nullptr, // tp_as_mapping
  nullptr, // tp_hash
  nullptr, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  PyvtkGDCMPolyDataWriter_Doc, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  nullptr, // tp_clear
  nullptr, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  nullptr, // tp_iter
  nullptr, // tp_iternext
  nullptr, // tp_methods
  nullptr, // tp_members
  PyVTKObject_GetSet, // tp_getset
  nullptr, // tp_base
  nullptr, // tp_dict
  nullptr, // tp_descr_get
  nullptr, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  nullptr, // tp_init
  nullptr, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  nullptr, // tp_is_gc
  nullptr, // tp_bases
  nullptr, // tp_mro
  nullptr, // tp_cache
  nullptr, // tp_subclasses
  nullptr, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkGDCMPolyDataWriter_StaticNew()
{
  return vtkGDCMPolyDataWriter::New();
}

PyObject *PyvtkGDCMPolyDataWriter_ClassNew()
{
  PyTypeObject *pytype = PyVTKClass_Add(
    &PyvtkGDCMPolyDataWriter_Type, PyvtkGDCMPolyDataWriter_Methods,
    "vtkGDCMPolyDataWriter",
 &PyvtkGDCMPolyDataWriter_StaticNew);

  if ((PyType_GetFlags(pytype) & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

  pytype->tp_base = vtkPythonUtil::FindBaseTypeObject("vtkPolyDataWriter");

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

void PyVTKAddFile_vtkGDCMPolyDataWriter(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkGDCMPolyDataWriter_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkGDCMPolyDataWriter", o) != 0)
  {
    Py_DECREF(o);
  }

}

