// python wrapper for vtkRTStructSetProperties
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkRTStructSetProperties.h"

#if defined(PYTHON_PACKAGE)
#define PYTHON_PACKAGE_SCOPE PYTHON_PACKAGE "."
#else
#define PYTHON_PACKAGE_SCOPE
#endif

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkRTStructSetProperties(PyObject *dict); }
extern "C" { PyObject *PyvtkRTStructSetProperties_ClassNew(); }


static PyObject *
PyvtkRTStructSetProperties_IsTypeOf(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkRTStructSetProperties::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkRTStructSetProperties_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkRTStructSetProperties *op = static_cast<vtkRTStructSetProperties *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkRTStructSetProperties::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkRTStructSetProperties_SafeDownCast(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkRTStructSetProperties *tempr = vtkRTStructSetProperties::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkRTStructSetProperties_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkRTStructSetProperties *op = static_cast<vtkRTStructSetProperties *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkRTStructSetProperties *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkRTStructSetProperties::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(nullptr);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
    else if (tempr != nullptr)
    {
      ap.DeleteVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkRTStructSetProperties_GetNumberOfGenerationsFromBaseType(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "GetNumberOfGenerationsFromBaseType");

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    long long tempr = vtkRTStructSetProperties::GetNumberOfGenerationsFromBaseType(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkRTStructSetProperties_GetNumberOfGenerationsFromBase(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNumberOfGenerationsFromBase");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkRTStructSetProperties *op = static_cast<vtkRTStructSetProperties *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    long long tempr = (ap.IsBound() ?
      op->GetNumberOfGenerationsFromBase(temp0) :
      op->vtkRTStructSetProperties::GetNumberOfGenerationsFromBase(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkRTStructSetProperties_Clear(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Clear");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkRTStructSetProperties *op = static_cast<vtkRTStructSetProperties *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->Clear();
    }
    else
    {
      op->vtkRTStructSetProperties::Clear();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkRTStructSetProperties_SetStructureSetLabel(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetStructureSetLabel");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkRTStructSetProperties *op = static_cast<vtkRTStructSetProperties *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetStructureSetLabel(temp0);
    }
    else
    {
      op->vtkRTStructSetProperties::SetStructureSetLabel(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkRTStructSetProperties_GetStructureSetLabel(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetStructureSetLabel");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkRTStructSetProperties *op = static_cast<vtkRTStructSetProperties *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    char *tempr = (ap.IsBound() ?
      op->GetStructureSetLabel() :
      op->vtkRTStructSetProperties::GetStructureSetLabel());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkRTStructSetProperties_SetStructureSetName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetStructureSetName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkRTStructSetProperties *op = static_cast<vtkRTStructSetProperties *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetStructureSetName(temp0);
    }
    else
    {
      op->vtkRTStructSetProperties::SetStructureSetName(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkRTStructSetProperties_GetStructureSetName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetStructureSetName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkRTStructSetProperties *op = static_cast<vtkRTStructSetProperties *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    char *tempr = (ap.IsBound() ?
      op->GetStructureSetName() :
      op->vtkRTStructSetProperties::GetStructureSetName());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkRTStructSetProperties_SetStructureSetDate(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetStructureSetDate");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkRTStructSetProperties *op = static_cast<vtkRTStructSetProperties *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetStructureSetDate(temp0);
    }
    else
    {
      op->vtkRTStructSetProperties::SetStructureSetDate(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkRTStructSetProperties_GetStructureSetDate(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetStructureSetDate");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkRTStructSetProperties *op = static_cast<vtkRTStructSetProperties *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    char *tempr = (ap.IsBound() ?
      op->GetStructureSetDate() :
      op->vtkRTStructSetProperties::GetStructureSetDate());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkRTStructSetProperties_SetStructureSetTime(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetStructureSetTime");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkRTStructSetProperties *op = static_cast<vtkRTStructSetProperties *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetStructureSetTime(temp0);
    }
    else
    {
      op->vtkRTStructSetProperties::SetStructureSetTime(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkRTStructSetProperties_GetStructureSetTime(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetStructureSetTime");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkRTStructSetProperties *op = static_cast<vtkRTStructSetProperties *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    char *tempr = (ap.IsBound() ?
      op->GetStructureSetTime() :
      op->vtkRTStructSetProperties::GetStructureSetTime());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkRTStructSetProperties_SetSOPInstanceUID(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetSOPInstanceUID");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkRTStructSetProperties *op = static_cast<vtkRTStructSetProperties *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetSOPInstanceUID(temp0);
    }
    else
    {
      op->vtkRTStructSetProperties::SetSOPInstanceUID(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkRTStructSetProperties_GetSOPInstanceUID(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetSOPInstanceUID");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkRTStructSetProperties *op = static_cast<vtkRTStructSetProperties *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    char *tempr = (ap.IsBound() ?
      op->GetSOPInstanceUID() :
      op->vtkRTStructSetProperties::GetSOPInstanceUID());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkRTStructSetProperties_SetStudyInstanceUID(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetStudyInstanceUID");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkRTStructSetProperties *op = static_cast<vtkRTStructSetProperties *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetStudyInstanceUID(temp0);
    }
    else
    {
      op->vtkRTStructSetProperties::SetStudyInstanceUID(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkRTStructSetProperties_GetStudyInstanceUID(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetStudyInstanceUID");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkRTStructSetProperties *op = static_cast<vtkRTStructSetProperties *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    char *tempr = (ap.IsBound() ?
      op->GetStudyInstanceUID() :
      op->vtkRTStructSetProperties::GetStudyInstanceUID());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkRTStructSetProperties_SetSeriesInstanceUID(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetSeriesInstanceUID");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkRTStructSetProperties *op = static_cast<vtkRTStructSetProperties *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetSeriesInstanceUID(temp0);
    }
    else
    {
      op->vtkRTStructSetProperties::SetSeriesInstanceUID(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkRTStructSetProperties_GetSeriesInstanceUID(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetSeriesInstanceUID");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkRTStructSetProperties *op = static_cast<vtkRTStructSetProperties *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    char *tempr = (ap.IsBound() ?
      op->GetSeriesInstanceUID() :
      op->vtkRTStructSetProperties::GetSeriesInstanceUID());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkRTStructSetProperties_SetReferenceSeriesInstanceUID(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetReferenceSeriesInstanceUID");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkRTStructSetProperties *op = static_cast<vtkRTStructSetProperties *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetReferenceSeriesInstanceUID(temp0);
    }
    else
    {
      op->vtkRTStructSetProperties::SetReferenceSeriesInstanceUID(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkRTStructSetProperties_GetReferenceSeriesInstanceUID(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetReferenceSeriesInstanceUID");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkRTStructSetProperties *op = static_cast<vtkRTStructSetProperties *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    char *tempr = (ap.IsBound() ?
      op->GetReferenceSeriesInstanceUID() :
      op->vtkRTStructSetProperties::GetReferenceSeriesInstanceUID());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkRTStructSetProperties_SetReferenceFrameOfReferenceUID(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetReferenceFrameOfReferenceUID");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkRTStructSetProperties *op = static_cast<vtkRTStructSetProperties *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetReferenceFrameOfReferenceUID(temp0);
    }
    else
    {
      op->vtkRTStructSetProperties::SetReferenceFrameOfReferenceUID(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkRTStructSetProperties_GetReferenceFrameOfReferenceUID(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetReferenceFrameOfReferenceUID");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkRTStructSetProperties *op = static_cast<vtkRTStructSetProperties *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    char *tempr = (ap.IsBound() ?
      op->GetReferenceFrameOfReferenceUID() :
      op->vtkRTStructSetProperties::GetReferenceFrameOfReferenceUID());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkRTStructSetProperties_DeepCopy(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "DeepCopy");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkRTStructSetProperties *op = static_cast<vtkRTStructSetProperties *>(vp);

  vtkRTStructSetProperties *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkRTStructSetProperties"))
  {
    if (ap.IsBound())
    {
      op->DeepCopy(temp0);
    }
    else
    {
      op->vtkRTStructSetProperties::DeepCopy(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkRTStructSetProperties_AddContourReferencedFrameOfReference(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "AddContourReferencedFrameOfReference");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkRTStructSetProperties *op = static_cast<vtkRTStructSetProperties *>(vp);

  long long temp0;
  const char *temp1 = nullptr;
  const char *temp2 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(3) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1) &&
      ap.GetValue(temp2))
  {
    if (ap.IsBound())
    {
      op->AddContourReferencedFrameOfReference(temp0, temp1, temp2);
    }
    else
    {
      op->vtkRTStructSetProperties::AddContourReferencedFrameOfReference(temp0, temp1, temp2);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkRTStructSetProperties_GetContourReferencedFrameOfReferenceClassUID(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetContourReferencedFrameOfReferenceClassUID");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkRTStructSetProperties *op = static_cast<vtkRTStructSetProperties *>(vp);

  long long temp0;
  long long temp1;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetContourReferencedFrameOfReferenceClassUID(temp0, temp1) :
      op->vtkRTStructSetProperties::GetContourReferencedFrameOfReferenceClassUID(temp0, temp1));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkRTStructSetProperties_GetContourReferencedFrameOfReferenceInstanceUID(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetContourReferencedFrameOfReferenceInstanceUID");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkRTStructSetProperties *op = static_cast<vtkRTStructSetProperties *>(vp);

  long long temp0;
  long long temp1;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetContourReferencedFrameOfReferenceInstanceUID(temp0, temp1) :
      op->vtkRTStructSetProperties::GetContourReferencedFrameOfReferenceInstanceUID(temp0, temp1));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkRTStructSetProperties_GetNumberOfContourReferencedFrameOfReferences_s1(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNumberOfContourReferencedFrameOfReferences");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkRTStructSetProperties *op = static_cast<vtkRTStructSetProperties *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    long long tempr = (ap.IsBound() ?
      op->GetNumberOfContourReferencedFrameOfReferences() :
      op->vtkRTStructSetProperties::GetNumberOfContourReferencedFrameOfReferences());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyObject *
PyvtkRTStructSetProperties_GetNumberOfContourReferencedFrameOfReferences_s2(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNumberOfContourReferencedFrameOfReferences");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkRTStructSetProperties *op = static_cast<vtkRTStructSetProperties *>(vp);

  long long temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    long long tempr = (ap.IsBound() ?
      op->GetNumberOfContourReferencedFrameOfReferences(temp0) :
      op->vtkRTStructSetProperties::GetNumberOfContourReferencedFrameOfReferences(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyObject *
PyvtkRTStructSetProperties_GetNumberOfContourReferencedFrameOfReferences(PyObject *self, PyObject *args)
{
  int nargs = vtkPythonArgs::GetArgCount(self, args);

  switch(nargs)
  {
    case 0:
      return PyvtkRTStructSetProperties_GetNumberOfContourReferencedFrameOfReferences_s1(self, args);
    case 1:
      return PyvtkRTStructSetProperties_GetNumberOfContourReferencedFrameOfReferences_s2(self, args);
  }

  vtkPythonArgs::ArgCountError(nargs, "GetNumberOfContourReferencedFrameOfReferences");
  return nullptr;
}


static PyObject *
PyvtkRTStructSetProperties_AddReferencedFrameOfReference(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "AddReferencedFrameOfReference");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkRTStructSetProperties *op = static_cast<vtkRTStructSetProperties *>(vp);

  const char *temp0 = nullptr;
  const char *temp1 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
  {
    if (ap.IsBound())
    {
      op->AddReferencedFrameOfReference(temp0, temp1);
    }
    else
    {
      op->vtkRTStructSetProperties::AddReferencedFrameOfReference(temp0, temp1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkRTStructSetProperties_GetReferencedFrameOfReferenceClassUID(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetReferencedFrameOfReferenceClassUID");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkRTStructSetProperties *op = static_cast<vtkRTStructSetProperties *>(vp);

  long long temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetReferencedFrameOfReferenceClassUID(temp0) :
      op->vtkRTStructSetProperties::GetReferencedFrameOfReferenceClassUID(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkRTStructSetProperties_GetReferencedFrameOfReferenceInstanceUID(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetReferencedFrameOfReferenceInstanceUID");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkRTStructSetProperties *op = static_cast<vtkRTStructSetProperties *>(vp);

  long long temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetReferencedFrameOfReferenceInstanceUID(temp0) :
      op->vtkRTStructSetProperties::GetReferencedFrameOfReferenceInstanceUID(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkRTStructSetProperties_GetNumberOfReferencedFrameOfReferences(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNumberOfReferencedFrameOfReferences");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkRTStructSetProperties *op = static_cast<vtkRTStructSetProperties *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    long long tempr = (ap.IsBound() ?
      op->GetNumberOfReferencedFrameOfReferences() :
      op->vtkRTStructSetProperties::GetNumberOfReferencedFrameOfReferences());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkRTStructSetProperties_AddStructureSetROI(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "AddStructureSetROI");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkRTStructSetProperties *op = static_cast<vtkRTStructSetProperties *>(vp);

  int temp0;
  const char *temp1 = nullptr;
  const char *temp2 = nullptr;
  const char *temp3 = nullptr;
  const char *temp4 = 0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(4, 5) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1) &&
      ap.GetValue(temp2) &&
      ap.GetValue(temp3) &&
      (ap.NoArgsLeft() || ap.GetValue(temp4)))
  {
    if (ap.IsBound())
    {
      op->AddStructureSetROI(temp0, temp1, temp2, temp3, temp4);
    }
    else
    {
      op->vtkRTStructSetProperties::AddStructureSetROI(temp0, temp1, temp2, temp3, temp4);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkRTStructSetProperties_AddStructureSetROIObservation(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "AddStructureSetROIObservation");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkRTStructSetProperties *op = static_cast<vtkRTStructSetProperties *>(vp);

  int temp0;
  int temp1;
  const char *temp2 = nullptr;
  const char *temp3 = nullptr;
  const char *temp4 = 0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(4, 5) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1) &&
      ap.GetValue(temp2) &&
      ap.GetValue(temp3) &&
      (ap.NoArgsLeft() || ap.GetValue(temp4)))
  {
    if (ap.IsBound())
    {
      op->AddStructureSetROIObservation(temp0, temp1, temp2, temp3, temp4);
    }
    else
    {
      op->vtkRTStructSetProperties::AddStructureSetROIObservation(temp0, temp1, temp2, temp3, temp4);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkRTStructSetProperties_GetNumberOfStructureSetROIs(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNumberOfStructureSetROIs");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkRTStructSetProperties *op = static_cast<vtkRTStructSetProperties *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    long long tempr = (ap.IsBound() ?
      op->GetNumberOfStructureSetROIs() :
      op->vtkRTStructSetProperties::GetNumberOfStructureSetROIs());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkRTStructSetProperties_GetStructureSetObservationNumber(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetStructureSetObservationNumber");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkRTStructSetProperties *op = static_cast<vtkRTStructSetProperties *>(vp);

  long long temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->GetStructureSetObservationNumber(temp0) :
      op->vtkRTStructSetProperties::GetStructureSetObservationNumber(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkRTStructSetProperties_GetStructureSetROINumber(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetStructureSetROINumber");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkRTStructSetProperties *op = static_cast<vtkRTStructSetProperties *>(vp);

  long long temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->GetStructureSetROINumber(temp0) :
      op->vtkRTStructSetProperties::GetStructureSetROINumber(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkRTStructSetProperties_GetStructureSetROIRefFrameRefUID(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetStructureSetROIRefFrameRefUID");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkRTStructSetProperties *op = static_cast<vtkRTStructSetProperties *>(vp);

  long long temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetStructureSetROIRefFrameRefUID(temp0) :
      op->vtkRTStructSetProperties::GetStructureSetROIRefFrameRefUID(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkRTStructSetProperties_GetStructureSetROIName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetStructureSetROIName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkRTStructSetProperties *op = static_cast<vtkRTStructSetProperties *>(vp);

  long long temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetStructureSetROIName(temp0) :
      op->vtkRTStructSetProperties::GetStructureSetROIName(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkRTStructSetProperties_GetStructureSetROIGenerationAlgorithm(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetStructureSetROIGenerationAlgorithm");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkRTStructSetProperties *op = static_cast<vtkRTStructSetProperties *>(vp);

  long long temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetStructureSetROIGenerationAlgorithm(temp0) :
      op->vtkRTStructSetProperties::GetStructureSetROIGenerationAlgorithm(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkRTStructSetProperties_GetStructureSetROIDescription(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetStructureSetROIDescription");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkRTStructSetProperties *op = static_cast<vtkRTStructSetProperties *>(vp);

  long long temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetStructureSetROIDescription(temp0) :
      op->vtkRTStructSetProperties::GetStructureSetROIDescription(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkRTStructSetProperties_GetStructureSetRTROIInterpretedType(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetStructureSetRTROIInterpretedType");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkRTStructSetProperties *op = static_cast<vtkRTStructSetProperties *>(vp);

  long long temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetStructureSetRTROIInterpretedType(temp0) :
      op->vtkRTStructSetProperties::GetStructureSetRTROIInterpretedType(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkRTStructSetProperties_GetStructureSetROIObservationLabel(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetStructureSetROIObservationLabel");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkRTStructSetProperties *op = static_cast<vtkRTStructSetProperties *>(vp);

  long long temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetStructureSetROIObservationLabel(temp0) :
      op->vtkRTStructSetProperties::GetStructureSetROIObservationLabel(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkRTStructSetProperties_Methods[] = {
  {"IsTypeOf", PyvtkRTStructSetProperties_IsTypeOf, METH_VARARGS,
   "IsTypeOf(type:str) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\nReturn 1 if this class type is the same type of (or a subclass\nof) the named class. Returns 0 otherwise. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"IsA", PyvtkRTStructSetProperties_IsA, METH_VARARGS,
   "IsA(self, type:str) -> int\nC++: vtkTypeBool IsA(const char *type) override;\n\nReturn 1 if this class is the same type of (or a subclass of) the\nnamed class. Returns 0 otherwise. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"SafeDownCast", PyvtkRTStructSetProperties_SafeDownCast, METH_VARARGS,
   "SafeDownCast(o:vtkObjectBase) -> vtkRTStructSetProperties\nC++: static vtkRTStructSetProperties *SafeDownCast(\n    vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkRTStructSetProperties_NewInstance, METH_VARARGS,
   "NewInstance(self) -> vtkRTStructSetProperties\nC++: vtkRTStructSetProperties *NewInstance()\n\n"},
  {"GetNumberOfGenerationsFromBaseType", PyvtkRTStructSetProperties_GetNumberOfGenerationsFromBaseType, METH_VARARGS,
   "GetNumberOfGenerationsFromBaseType(type:str) -> int\nC++: static vtkIdType GetNumberOfGenerationsFromBaseType(\n    const char *type)\n\nGiven a the name of a base class of this class type, return the\ndistance of inheritance between this class type and the named\nclass (how many generations of inheritance are there between this\nclass and the named class). If the named class is not in this\nclass's inheritance tree, return a negative value. Valid\nresponses will always be nonnegative. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"GetNumberOfGenerationsFromBase", PyvtkRTStructSetProperties_GetNumberOfGenerationsFromBase, METH_VARARGS,
   "GetNumberOfGenerationsFromBase(self, type:str) -> int\nC++: vtkIdType GetNumberOfGenerationsFromBase(const char *type)\n    override;\n\nGiven the name of a base class of this class type, return the\ndistance of inheritance between this class type and the named\nclass (how many generations of inheritance are there between this\nclass and the named class). If the named class is not in this\nclass's inheritance tree, return a negative value. Valid\nresponses will always be nonnegative. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"Clear", PyvtkRTStructSetProperties_Clear, METH_VARARGS,
   "Clear(self) -> None\nC++: virtual void Clear()\n\nConvenience method to reset all fields to an empty string/value\n"},
  {"SetStructureSetLabel", PyvtkRTStructSetProperties_SetStructureSetLabel, METH_VARARGS,
   "SetStructureSetLabel(self, _arg:str) -> None\nC++: virtual void SetStructureSetLabel(const char *_arg)\n\n\n"},
  {"GetStructureSetLabel", PyvtkRTStructSetProperties_GetStructureSetLabel, METH_VARARGS,
   "GetStructureSetLabel(self) -> str\nC++: virtual char *GetStructureSetLabel()\n\n\n"},
  {"SetStructureSetName", PyvtkRTStructSetProperties_SetStructureSetName, METH_VARARGS,
   "SetStructureSetName(self, _arg:str) -> None\nC++: virtual void SetStructureSetName(const char *_arg)\n\n"},
  {"GetStructureSetName", PyvtkRTStructSetProperties_GetStructureSetName, METH_VARARGS,
   "GetStructureSetName(self) -> str\nC++: virtual char *GetStructureSetName()\n\n"},
  {"SetStructureSetDate", PyvtkRTStructSetProperties_SetStructureSetDate, METH_VARARGS,
   "SetStructureSetDate(self, _arg:str) -> None\nC++: virtual void SetStructureSetDate(const char *_arg)\n\n"},
  {"GetStructureSetDate", PyvtkRTStructSetProperties_GetStructureSetDate, METH_VARARGS,
   "GetStructureSetDate(self) -> str\nC++: virtual char *GetStructureSetDate()\n\n"},
  {"SetStructureSetTime", PyvtkRTStructSetProperties_SetStructureSetTime, METH_VARARGS,
   "SetStructureSetTime(self, _arg:str) -> None\nC++: virtual void SetStructureSetTime(const char *_arg)\n\n"},
  {"GetStructureSetTime", PyvtkRTStructSetProperties_GetStructureSetTime, METH_VARARGS,
   "GetStructureSetTime(self) -> str\nC++: virtual char *GetStructureSetTime()\n\n"},
  {"SetSOPInstanceUID", PyvtkRTStructSetProperties_SetSOPInstanceUID, METH_VARARGS,
   "SetSOPInstanceUID(self, _arg:str) -> None\nC++: virtual void SetSOPInstanceUID(const char *_arg)\n\n"},
  {"GetSOPInstanceUID", PyvtkRTStructSetProperties_GetSOPInstanceUID, METH_VARARGS,
   "GetSOPInstanceUID(self) -> str\nC++: virtual char *GetSOPInstanceUID()\n\n"},
  {"SetStudyInstanceUID", PyvtkRTStructSetProperties_SetStudyInstanceUID, METH_VARARGS,
   "SetStudyInstanceUID(self, _arg:str) -> None\nC++: virtual void SetStudyInstanceUID(const char *_arg)\n\n"},
  {"GetStudyInstanceUID", PyvtkRTStructSetProperties_GetStudyInstanceUID, METH_VARARGS,
   "GetStudyInstanceUID(self) -> str\nC++: virtual char *GetStudyInstanceUID()\n\n"},
  {"SetSeriesInstanceUID", PyvtkRTStructSetProperties_SetSeriesInstanceUID, METH_VARARGS,
   "SetSeriesInstanceUID(self, _arg:str) -> None\nC++: virtual void SetSeriesInstanceUID(const char *_arg)\n\n"},
  {"GetSeriesInstanceUID", PyvtkRTStructSetProperties_GetSeriesInstanceUID, METH_VARARGS,
   "GetSeriesInstanceUID(self) -> str\nC++: virtual char *GetSeriesInstanceUID()\n\n"},
  {"SetReferenceSeriesInstanceUID", PyvtkRTStructSetProperties_SetReferenceSeriesInstanceUID, METH_VARARGS,
   "SetReferenceSeriesInstanceUID(self, _arg:str) -> None\nC++: virtual void SetReferenceSeriesInstanceUID(const char *_arg)\n\n"},
  {"GetReferenceSeriesInstanceUID", PyvtkRTStructSetProperties_GetReferenceSeriesInstanceUID, METH_VARARGS,
   "GetReferenceSeriesInstanceUID(self) -> str\nC++: virtual char *GetReferenceSeriesInstanceUID()\n\n"},
  {"SetReferenceFrameOfReferenceUID", PyvtkRTStructSetProperties_SetReferenceFrameOfReferenceUID, METH_VARARGS,
   "SetReferenceFrameOfReferenceUID(self, _arg:str) -> None\nC++: virtual void SetReferenceFrameOfReferenceUID(\n    const char *_arg)\n\n"},
  {"GetReferenceFrameOfReferenceUID", PyvtkRTStructSetProperties_GetReferenceFrameOfReferenceUID, METH_VARARGS,
   "GetReferenceFrameOfReferenceUID(self) -> str\nC++: virtual char *GetReferenceFrameOfReferenceUID()\n\n"},
  {"DeepCopy", PyvtkRTStructSetProperties_DeepCopy, METH_VARARGS,
   "DeepCopy(self, p:vtkRTStructSetProperties) -> None\nC++: virtual void DeepCopy(vtkRTStructSetProperties *p)\n\nCopy the contents of p to this instance.\n"},
  {"AddContourReferencedFrameOfReference", PyvtkRTStructSetProperties_AddContourReferencedFrameOfReference, METH_VARARGS,
   "AddContourReferencedFrameOfReference(self, pdnum:int,\n    classuid:str, instanceuid:str) -> None\nC++: void AddContourReferencedFrameOfReference(vtkIdType pdnum,\n    const char *classuid, const char *instanceuid)\n\n"},
  {"GetContourReferencedFrameOfReferenceClassUID", PyvtkRTStructSetProperties_GetContourReferencedFrameOfReferenceClassUID, METH_VARARGS,
   "GetContourReferencedFrameOfReferenceClassUID(self, pdnum:int,\n    id:int) -> str\nC++: const char *GetContourReferencedFrameOfReferenceClassUID(\n    vtkIdType pdnum, vtkIdType id)\n\n"},
  {"GetContourReferencedFrameOfReferenceInstanceUID", PyvtkRTStructSetProperties_GetContourReferencedFrameOfReferenceInstanceUID, METH_VARARGS,
   "GetContourReferencedFrameOfReferenceInstanceUID(self, pdnum:int,\n    id:int) -> str\nC++: const char *GetContourReferencedFrameOfReferenceInstanceUID(\n    vtkIdType pdnum, vtkIdType id)\n\n"},
  {"GetNumberOfContourReferencedFrameOfReferences", PyvtkRTStructSetProperties_GetNumberOfContourReferencedFrameOfReferences, METH_VARARGS,
   "GetNumberOfContourReferencedFrameOfReferences(self) -> int\nC++: vtkIdType GetNumberOfContourReferencedFrameOfReferences()\nGetNumberOfContourReferencedFrameOfReferences(self, pdnum:int)\n    -> int\nC++: vtkIdType GetNumberOfContourReferencedFrameOfReferences(\n    vtkIdType pdnum)\n\n"},
  {"AddReferencedFrameOfReference", PyvtkRTStructSetProperties_AddReferencedFrameOfReference, METH_VARARGS,
   "AddReferencedFrameOfReference(self, classuid:str, instanceuid:str)\n     -> None\nC++: void AddReferencedFrameOfReference(const char *classuid,\n    const char *instanceuid)\n\n"},
  {"GetReferencedFrameOfReferenceClassUID", PyvtkRTStructSetProperties_GetReferencedFrameOfReferenceClassUID, METH_VARARGS,
   "GetReferencedFrameOfReferenceClassUID(self, id:int) -> str\nC++: const char *GetReferencedFrameOfReferenceClassUID(\n    vtkIdType id)\n\n"},
  {"GetReferencedFrameOfReferenceInstanceUID", PyvtkRTStructSetProperties_GetReferencedFrameOfReferenceInstanceUID, METH_VARARGS,
   "GetReferencedFrameOfReferenceInstanceUID(self, id:int) -> str\nC++: const char *GetReferencedFrameOfReferenceInstanceUID(\n    vtkIdType id)\n\n"},
  {"GetNumberOfReferencedFrameOfReferences", PyvtkRTStructSetProperties_GetNumberOfReferencedFrameOfReferences, METH_VARARGS,
   "GetNumberOfReferencedFrameOfReferences(self) -> int\nC++: vtkIdType GetNumberOfReferencedFrameOfReferences()\n\n"},
  {"AddStructureSetROI", PyvtkRTStructSetProperties_AddStructureSetROI, METH_VARARGS,
   "AddStructureSetROI(self, roinumber:int, refframerefuid:str,\n    roiname:str, ROIGenerationAlgorithm:str, ROIDescription:str=0)\n     -> None\nC++: void AddStructureSetROI(int roinumber,\n    const char *refframerefuid, const char *roiname,\n    const char *ROIGenerationAlgorithm,\n    const char *ROIDescription=0)\n\n"},
  {"AddStructureSetROIObservation", PyvtkRTStructSetProperties_AddStructureSetROIObservation, METH_VARARGS,
   "AddStructureSetROIObservation(self, refnumber:int,\n    observationnumber:int, rtroiinterpretedtype:str,\n    roiinterpreter:str, roiobservationlabel:str=0) -> None\nC++: void AddStructureSetROIObservation(int refnumber,\n    int observationnumber, const char *rtroiinterpretedtype,\n    const char *roiinterpreter, const char *roiobservationlabel=0)\n\n"},
  {"GetNumberOfStructureSetROIs", PyvtkRTStructSetProperties_GetNumberOfStructureSetROIs, METH_VARARGS,
   "GetNumberOfStructureSetROIs(self) -> int\nC++: vtkIdType GetNumberOfStructureSetROIs()\n\n"},
  {"GetStructureSetObservationNumber", PyvtkRTStructSetProperties_GetStructureSetObservationNumber, METH_VARARGS,
   "GetStructureSetObservationNumber(self, id:int) -> int\nC++: int GetStructureSetObservationNumber(vtkIdType id)\n\n"},
  {"GetStructureSetROINumber", PyvtkRTStructSetProperties_GetStructureSetROINumber, METH_VARARGS,
   "GetStructureSetROINumber(self, id:int) -> int\nC++: int GetStructureSetROINumber(vtkIdType id)\n\n"},
  {"GetStructureSetROIRefFrameRefUID", PyvtkRTStructSetProperties_GetStructureSetROIRefFrameRefUID, METH_VARARGS,
   "GetStructureSetROIRefFrameRefUID(self, __a:int) -> str\nC++: const char *GetStructureSetROIRefFrameRefUID(vtkIdType)\n\n"},
  {"GetStructureSetROIName", PyvtkRTStructSetProperties_GetStructureSetROIName, METH_VARARGS,
   "GetStructureSetROIName(self, __a:int) -> str\nC++: const char *GetStructureSetROIName(vtkIdType)\n\n"},
  {"GetStructureSetROIGenerationAlgorithm", PyvtkRTStructSetProperties_GetStructureSetROIGenerationAlgorithm, METH_VARARGS,
   "GetStructureSetROIGenerationAlgorithm(self, __a:int) -> str\nC++: const char *GetStructureSetROIGenerationAlgorithm(vtkIdType)\n\n"},
  {"GetStructureSetROIDescription", PyvtkRTStructSetProperties_GetStructureSetROIDescription, METH_VARARGS,
   "GetStructureSetROIDescription(self, id:int) -> str\nC++: const char *GetStructureSetROIDescription(vtkIdType id)\n\n"},
  {"GetStructureSetRTROIInterpretedType", PyvtkRTStructSetProperties_GetStructureSetRTROIInterpretedType, METH_VARARGS,
   "GetStructureSetRTROIInterpretedType(self, id:int) -> str\nC++: const char *GetStructureSetRTROIInterpretedType(vtkIdType id)\n\n"},
  {"GetStructureSetROIObservationLabel", PyvtkRTStructSetProperties_GetStructureSetROIObservationLabel, METH_VARARGS,
   "GetStructureSetROIObservationLabel(self, id:int) -> str\nC++: const char *GetStructureSetROIObservationLabel(vtkIdType id)\n\n"},
  {nullptr, nullptr, 0, nullptr}
};

static const char *PyvtkRTStructSetProperties_Doc =
  "vtkRTStructSetProperties - some rtstruct properties.\n\n"
  "Superclass: vtkObject\n\n"
  "See Also:\n\n"
  "vtkGDCMPolyDataReader vtkGDCMPolyDataWriter\n\n";

#ifdef VTK_PYTHON_NEEDS_DEPRECATION_WARNING_SUPPRESSION
#pragma GCC diagnostic ignored "-Wdeprecated-declarations"
#endif

static PyTypeObject PyvtkRTStructSetProperties_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  PYTHON_PACKAGE_SCOPE "vtkgdcm.vtkRTStructSetProperties", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
#if PY_VERSION_HEX >= 0x03080000
  0, // tp_vectorcall_offset
#else
  nullptr, // tp_print
#endif
  nullptr, // tp_getattr
  nullptr, // tp_setattr
  nullptr, // tp_compare
  PyVTKObject_Repr, // tp_repr
  nullptr, // tp_as_number
  nullptr, // tp_as_sequence
  nullptr, // tp_as_mapping
  nullptr, // tp_hash
  nullptr, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  PyvtkRTStructSetProperties_Doc, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  nullptr, // tp_clear
  nullptr, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  nullptr, // tp_iter
  nullptr, // tp_iternext
  nullptr, // tp_methods
  nullptr, // tp_members
  PyVTKObject_GetSet, // tp_getset
  nullptr, // tp_base
  nullptr, // tp_dict
  nullptr, // tp_descr_get
  nullptr, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  nullptr, // tp_init
  nullptr, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  nullptr, // tp_is_gc
  nullptr, // tp_bases
  nullptr, // tp_mro
  nullptr, // tp_cache
  nullptr, // tp_subclasses
  nullptr, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkRTStructSetProperties_StaticNew()
{
  return vtkRTStructSetProperties::New();
}

PyObject *PyvtkRTStructSetProperties_ClassNew()
{
  PyTypeObject *pytype = PyVTKClass_Add(
    &PyvtkRTStructSetProperties_Type, PyvtkRTStructSetProperties_Methods,
    "vtkRTStructSetProperties",
 &PyvtkRTStructSetProperties_StaticNew);

  if ((PyType_GetFlags(pytype) & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

  pytype->tp_base = vtkPythonUtil::FindBaseTypeObject("vtkObject");

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

void PyVTKAddFile_vtkRTStructSetProperties(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkRTStructSetProperties_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkRTStructSetProperties", o) != 0)
  {
    Py_DECREF(o);
  }

}

